(set-logic BV)

(declare-const inv_s (_ BitVec 48))
(declare-const t (_ BitVec 48))
(declare-const xlo (_ BitVec 48))
(declare-const xhi (_ BitVec 48))

(define-fun mcb ((xlo (_ BitVec 48)) (xhi (_ BitVec 48)) (v (_ BitVec 48))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 48))) (_ BitVec 48)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (_ bv48 48) (_ bv47 48)) (_ bv46 48)) (_ bv45 48)) (_ bv44 48)) (_ bv43 48)) (_ bv42 48)) (_ bv41 48)) (_ bv40 48)) (_ bv39 48)) (_ bv38 48)) (_ bv37 48)) (_ bv36 48)) (_ bv35 48)) (_ bv34 48)) (_ bv33 48)) (_ bv32 48)) (_ bv31 48)) (_ bv30 48)) (_ bv29 48)) (_ bv28 48)) (_ bv27 48)) (_ bv26 48)) (_ bv25 48)) (_ bv24 48)) (_ bv23 48)) (_ bv22 48)) (_ bv21 48)) (_ bv20 48)) (_ bv19 48)) (_ bv18 48)) (_ bv17 48)) (_ bv16 48)) (_ bv15 48)) (_ bv14 48)) (_ bv13 48)) (_ bv12 48)) (_ bv11 48)) (_ bv10 48)) (_ bv9 48)) (_ bv8 48)) (_ bv7 48)) (_ bv6 48)) (_ bv5 48)) (_ bv4 48)) (_ bv3 48)) (_ bv2 48)) (_ bv1 48)) (_ bv0 48))
)

(define-fun clz ((v (_ BitVec 48))) (_ BitVec 48)
 (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv48 48) (_ bv47 48)) (_ bv46 48)) (_ bv45 48)) (_ bv44 48)) (_ bv43 48)) (_ bv42 48)) (_ bv41 48)) (_ bv40 48)) (_ bv39 48)) (_ bv38 48)) (_ bv37 48)) (_ bv36 48)) (_ bv35 48)) (_ bv34 48)) (_ bv33 48)) (_ bv32 48)) (_ bv31 48)) (_ bv30 48)) (_ bv29 48)) (_ bv28 48)) (_ bv27 48)) (_ bv26 48)) (_ bv25 48)) (_ bv24 48)) (_ bv23 48)) (_ bv22 48)) (_ bv21 48)) (_ bv20 48)) (_ bv19 48)) (_ bv18 48)) (_ bv17 48)) (_ bv16 48)) (_ bv15 48)) (_ bv14 48)) (_ bv13 48)) (_ bv12 48)) (_ bv11 48)) (_ bv10 48)) (_ bv9 48)) (_ bv8 48)) (_ bv7 48)) (_ bv6 48)) (_ bv5 48)) (_ bv4 48)) (_ bv3 48)) (_ bv2 48)) (_ bv1 48)) (_ bv0 48))
)

(define-fun cto ((v (_ BitVec 48))) (_ BitVec 48)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 48))) (_ BitVec 48)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 48))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 48)
 (_ bv0 48)
)

(define-fun one () (_ BitVec 48)
 (_ bv1 48)
)

(define-fun ones () (_ BitVec 48)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 48)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 48)
 (bvnot mins)
)

(define-fun w () (_ BitVec 48)
 (_ bv48 48)
)

(define-fun msb ((v (_ BitVec 48))) (_ BitVec 1)
 ((_ extract 47 47) v)
)

(define-fun CC ((t (_ BitVec 48)) (xlo (_ BitVec 48)) (xhi (_ BitVec 48))) Bool
 (distinct xhi zero)
)

(define-fun LIT ((x (_ BitVec 48)) (s (_ BitVec 48))) Bool
 (bvult s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 48)) (s (_ BitVec 48)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
