(set-logic BV)

(declare-const tx (_ BitVec 41))
(declare-const ts (_ BitVec 41))
(declare-const xlo (_ BitVec 41))
(declare-const xhi (_ BitVec 41))

(define-fun mcb ((xlo (_ BitVec 41)) (xhi (_ BitVec 41)) (v (_ BitVec 41))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 41))) (_ BitVec 41)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (_ bv41 41) (_ bv40 41)) (_ bv39 41)) (_ bv38 41)) (_ bv37 41)) (_ bv36 41)) (_ bv35 41)) (_ bv34 41)) (_ bv33 41)) (_ bv32 41)) (_ bv31 41)) (_ bv30 41)) (_ bv29 41)) (_ bv28 41)) (_ bv27 41)) (_ bv26 41)) (_ bv25 41)) (_ bv24 41)) (_ bv23 41)) (_ bv22 41)) (_ bv21 41)) (_ bv20 41)) (_ bv19 41)) (_ bv18 41)) (_ bv17 41)) (_ bv16 41)) (_ bv15 41)) (_ bv14 41)) (_ bv13 41)) (_ bv12 41)) (_ bv11 41)) (_ bv10 41)) (_ bv9 41)) (_ bv8 41)) (_ bv7 41)) (_ bv6 41)) (_ bv5 41)) (_ bv4 41)) (_ bv3 41)) (_ bv2 41)) (_ bv1 41)) (_ bv0 41))
)

(define-fun clz ((v (_ BitVec 41))) (_ BitVec 41)
 (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv41 41) (_ bv40 41)) (_ bv39 41)) (_ bv38 41)) (_ bv37 41)) (_ bv36 41)) (_ bv35 41)) (_ bv34 41)) (_ bv33 41)) (_ bv32 41)) (_ bv31 41)) (_ bv30 41)) (_ bv29 41)) (_ bv28 41)) (_ bv27 41)) (_ bv26 41)) (_ bv25 41)) (_ bv24 41)) (_ bv23 41)) (_ bv22 41)) (_ bv21 41)) (_ bv20 41)) (_ bv19 41)) (_ bv18 41)) (_ bv17 41)) (_ bv16 41)) (_ bv15 41)) (_ bv14 41)) (_ bv13 41)) (_ bv12 41)) (_ bv11 41)) (_ bv10 41)) (_ bv9 41)) (_ bv8 41)) (_ bv7 41)) (_ bv6 41)) (_ bv5 41)) (_ bv4 41)) (_ bv3 41)) (_ bv2 41)) (_ bv1 41)) (_ bv0 41))
)

(define-fun cto ((v (_ BitVec 41))) (_ BitVec 41)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 41))) (_ BitVec 41)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 41))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 41)
 (_ bv0 41)
)

(define-fun one () (_ BitVec 41)
 (_ bv1 41)
)

(define-fun ones () (_ BitVec 41)
 (bvnot zero)
)

(define-fun w () (_ BitVec 41)
 (_ bv41 41)
)

(define-fun CC ((tx (_ BitVec 41)) (ts (_ BitVec 41)) (xlo (_ BitVec 41)) (xhi (_ BitVec 41))) Bool
 (mcb xlo xhi tx)
)

(define-fun LIT ((x (_ BitVec 41)) (s (_ BitVec 41))) Bool
 (= (concat s x) (concat ts tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC tx ts xlo xhi)
  (exists ((x (_ BitVec 41)) (s (_ BitVec 41)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

