(set-logic BV)

(declare-const tx (_ BitVec 63))
(declare-const ts (_ BitVec 63))
(declare-const xlo (_ BitVec 63))
(declare-const xhi (_ BitVec 63))

(define-fun mcb ((xlo (_ BitVec 63)) (xhi (_ BitVec 63)) (v (_ BitVec 63))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 63))) (_ BitVec 63)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 62 62) v) #b0) (_ bv63 63) (_ bv62 63)) (_ bv61 63)) (_ bv60 63)) (_ bv59 63)) (_ bv58 63)) (_ bv57 63)) (_ bv56 63)) (_ bv55 63)) (_ bv54 63)) (_ bv53 63)) (_ bv52 63)) (_ bv51 63)) (_ bv50 63)) (_ bv49 63)) (_ bv48 63)) (_ bv47 63)) (_ bv46 63)) (_ bv45 63)) (_ bv44 63)) (_ bv43 63)) (_ bv42 63)) (_ bv41 63)) (_ bv40 63)) (_ bv39 63)) (_ bv38 63)) (_ bv37 63)) (_ bv36 63)) (_ bv35 63)) (_ bv34 63)) (_ bv33 63)) (_ bv32 63)) (_ bv31 63)) (_ bv30 63)) (_ bv29 63)) (_ bv28 63)) (_ bv27 63)) (_ bv26 63)) (_ bv25 63)) (_ bv24 63)) (_ bv23 63)) (_ bv22 63)) (_ bv21 63)) (_ bv20 63)) (_ bv19 63)) (_ bv18 63)) (_ bv17 63)) (_ bv16 63)) (_ bv15 63)) (_ bv14 63)) (_ bv13 63)) (_ bv12 63)) (_ bv11 63)) (_ bv10 63)) (_ bv9 63)) (_ bv8 63)) (_ bv7 63)) (_ bv6 63)) (_ bv5 63)) (_ bv4 63)) (_ bv3 63)) (_ bv2 63)) (_ bv1 63)) (_ bv0 63))
)

(define-fun clz ((v (_ BitVec 63))) (_ BitVec 63)
 (ite (= ((_ extract 62 62) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv63 63) (_ bv62 63)) (_ bv61 63)) (_ bv60 63)) (_ bv59 63)) (_ bv58 63)) (_ bv57 63)) (_ bv56 63)) (_ bv55 63)) (_ bv54 63)) (_ bv53 63)) (_ bv52 63)) (_ bv51 63)) (_ bv50 63)) (_ bv49 63)) (_ bv48 63)) (_ bv47 63)) (_ bv46 63)) (_ bv45 63)) (_ bv44 63)) (_ bv43 63)) (_ bv42 63)) (_ bv41 63)) (_ bv40 63)) (_ bv39 63)) (_ bv38 63)) (_ bv37 63)) (_ bv36 63)) (_ bv35 63)) (_ bv34 63)) (_ bv33 63)) (_ bv32 63)) (_ bv31 63)) (_ bv30 63)) (_ bv29 63)) (_ bv28 63)) (_ bv27 63)) (_ bv26 63)) (_ bv25 63)) (_ bv24 63)) (_ bv23 63)) (_ bv22 63)) (_ bv21 63)) (_ bv20 63)) (_ bv19 63)) (_ bv18 63)) (_ bv17 63)) (_ bv16 63)) (_ bv15 63)) (_ bv14 63)) (_ bv13 63)) (_ bv12 63)) (_ bv11 63)) (_ bv10 63)) (_ bv9 63)) (_ bv8 63)) (_ bv7 63)) (_ bv6 63)) (_ bv5 63)) (_ bv4 63)) (_ bv3 63)) (_ bv2 63)) (_ bv1 63)) (_ bv0 63))
)

(define-fun cto ((v (_ BitVec 63))) (_ BitVec 63)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 63))) (_ BitVec 63)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 63))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 63)
 (_ bv0 63)
)

(define-fun one () (_ BitVec 63)
 (_ bv1 63)
)

(define-fun ones () (_ BitVec 63)
 (bvnot zero)
)

(define-fun w () (_ BitVec 63)
 (_ bv63 63)
)

(define-fun CC ((tx (_ BitVec 63)) (ts (_ BitVec 63)) (xlo (_ BitVec 63)) (xhi (_ BitVec 63))) Bool
 (mcb xlo xhi tx)
)

(define-fun LIT ((x (_ BitVec 63)) (s (_ BitVec 63))) Bool
 (= (concat s x) (concat ts tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC tx ts xlo xhi)
  (exists ((x (_ BitVec 63)) (s (_ BitVec 63)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

