(set-logic BV)

(declare-const inv_s (_ BitVec 42))
(declare-const inv_s_ctz_s (_ BitVec 42))
(declare-const t (_ BitVec 42))
(declare-const xlo (_ BitVec 42))
(declare-const xhi (_ BitVec 42))

(define-fun mcb ((xlo (_ BitVec 42)) (xhi (_ BitVec 42)) (v (_ BitVec 42))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 42))) (_ BitVec 42)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (_ bv42 42) (_ bv41 42)) (_ bv40 42)) (_ bv39 42)) (_ bv38 42)) (_ bv37 42)) (_ bv36 42)) (_ bv35 42)) (_ bv34 42)) (_ bv33 42)) (_ bv32 42)) (_ bv31 42)) (_ bv30 42)) (_ bv29 42)) (_ bv28 42)) (_ bv27 42)) (_ bv26 42)) (_ bv25 42)) (_ bv24 42)) (_ bv23 42)) (_ bv22 42)) (_ bv21 42)) (_ bv20 42)) (_ bv19 42)) (_ bv18 42)) (_ bv17 42)) (_ bv16 42)) (_ bv15 42)) (_ bv14 42)) (_ bv13 42)) (_ bv12 42)) (_ bv11 42)) (_ bv10 42)) (_ bv9 42)) (_ bv8 42)) (_ bv7 42)) (_ bv6 42)) (_ bv5 42)) (_ bv4 42)) (_ bv3 42)) (_ bv2 42)) (_ bv1 42)) (_ bv0 42))
)

(define-fun clz ((v (_ BitVec 42))) (_ BitVec 42)
 (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv42 42) (_ bv41 42)) (_ bv40 42)) (_ bv39 42)) (_ bv38 42)) (_ bv37 42)) (_ bv36 42)) (_ bv35 42)) (_ bv34 42)) (_ bv33 42)) (_ bv32 42)) (_ bv31 42)) (_ bv30 42)) (_ bv29 42)) (_ bv28 42)) (_ bv27 42)) (_ bv26 42)) (_ bv25 42)) (_ bv24 42)) (_ bv23 42)) (_ bv22 42)) (_ bv21 42)) (_ bv20 42)) (_ bv19 42)) (_ bv18 42)) (_ bv17 42)) (_ bv16 42)) (_ bv15 42)) (_ bv14 42)) (_ bv13 42)) (_ bv12 42)) (_ bv11 42)) (_ bv10 42)) (_ bv9 42)) (_ bv8 42)) (_ bv7 42)) (_ bv6 42)) (_ bv5 42)) (_ bv4 42)) (_ bv3 42)) (_ bv2 42)) (_ bv1 42)) (_ bv0 42))
)

(define-fun cto ((v (_ BitVec 42))) (_ BitVec 42)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 42))) (_ BitVec 42)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 42))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 42)
 (_ bv0 42)
)

(define-fun one () (_ BitVec 42)
 (_ bv1 42)
)

(define-fun ones () (_ BitVec 42)
 (bvnot zero)
)

(define-fun w () (_ BitVec 42)
 (_ bv42 42)
)

(define-fun addo ((a (_ BitVec 42)) (b (_ BitVec 42))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 42 42) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 42)) (b (_ BitVec 42))) Bool
 (let ((zext_a ((_ zero_extend 42) a)) (zext_b ((_ zero_extend 42) b)))
  (distinct
   ((_ extract 41 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 42) (_ bv42 42))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 42)) (xlo (_ BitVec 42)) (xhi (_ BitVec 42))) Bool
 (and
  (=> (distinct t ones) (bvuge xhi t))
  (=> (= t zero) (distinct xlo ones))
  (=>
   (and
    (distinct t zero)
    (distinct t ones)
    (distinct t one)
    (not (mcb xlo xhi t))
   )
   (and
    (not (addo t t))
    (exists ((y (_ BitVec 42))(o (_ BitVec 42)))
     (and
      (mcb xlo xhi (bvadd (bvmul y t) o))
      (bvuge y one)
      (bvule o (ite (bvult (bvsub y one)(bvsub xhi (bvmul y t))) (bvsub y one) (bvsub xhi (bvmul y t))))
      (not (mulo y t))
      (not (addo (bvmul y t) o))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 42)) (s (_ BitVec 42))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))
(assert (distinct xlo xhi))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 42)) (s (_ BitVec 42)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

