(set-logic BV)

(declare-const s (_ BitVec 43))
(declare-const inv_s (_ BitVec 43))
(declare-const t (_ BitVec 43))
(declare-const xlo (_ BitVec 43))
(declare-const xhi (_ BitVec 43))

(define-fun mcb ((xlo (_ BitVec 43)) (xhi (_ BitVec 43)) (v (_ BitVec 43))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 43))) (_ BitVec 43)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (_ bv43 43) (_ bv42 43)) (_ bv41 43)) (_ bv40 43)) (_ bv39 43)) (_ bv38 43)) (_ bv37 43)) (_ bv36 43)) (_ bv35 43)) (_ bv34 43)) (_ bv33 43)) (_ bv32 43)) (_ bv31 43)) (_ bv30 43)) (_ bv29 43)) (_ bv28 43)) (_ bv27 43)) (_ bv26 43)) (_ bv25 43)) (_ bv24 43)) (_ bv23 43)) (_ bv22 43)) (_ bv21 43)) (_ bv20 43)) (_ bv19 43)) (_ bv18 43)) (_ bv17 43)) (_ bv16 43)) (_ bv15 43)) (_ bv14 43)) (_ bv13 43)) (_ bv12 43)) (_ bv11 43)) (_ bv10 43)) (_ bv9 43)) (_ bv8 43)) (_ bv7 43)) (_ bv6 43)) (_ bv5 43)) (_ bv4 43)) (_ bv3 43)) (_ bv2 43)) (_ bv1 43)) (_ bv0 43))
)

(define-fun clz ((v (_ BitVec 43))) (_ BitVec 43)
 (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv43 43) (_ bv42 43)) (_ bv41 43)) (_ bv40 43)) (_ bv39 43)) (_ bv38 43)) (_ bv37 43)) (_ bv36 43)) (_ bv35 43)) (_ bv34 43)) (_ bv33 43)) (_ bv32 43)) (_ bv31 43)) (_ bv30 43)) (_ bv29 43)) (_ bv28 43)) (_ bv27 43)) (_ bv26 43)) (_ bv25 43)) (_ bv24 43)) (_ bv23 43)) (_ bv22 43)) (_ bv21 43)) (_ bv20 43)) (_ bv19 43)) (_ bv18 43)) (_ bv17 43)) (_ bv16 43)) (_ bv15 43)) (_ bv14 43)) (_ bv13 43)) (_ bv12 43)) (_ bv11 43)) (_ bv10 43)) (_ bv9 43)) (_ bv8 43)) (_ bv7 43)) (_ bv6 43)) (_ bv5 43)) (_ bv4 43)) (_ bv3 43)) (_ bv2 43)) (_ bv1 43)) (_ bv0 43))
)

(define-fun cto ((v (_ BitVec 43))) (_ BitVec 43)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 43))) (_ BitVec 43)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 43))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 43)
 (_ bv0 43)
)

(define-fun one () (_ BitVec 43)
 (_ bv1 43)
)

(define-fun ones () (_ BitVec 43)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 43)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 43)
 (bvnot mins)
)

(define-fun w () (_ BitVec 43)
 (_ bv43 43)
)

(define-fun msb ((v (_ BitVec 43))) (_ BitVec 1)
 ((_ extract 42 42) v)
)

(define-fun IC ((s (_ BitVec 43)) (t (_ BitVec 43)) (xlo (_ BitVec 43)) (xhi (_ BitVec 43))) Bool
 (and (=> (bvult s w) (= (bvashr (bvshl t s) s) t)) (=> (bvuge s w) (or (= t ones) (= t zero))) (mcb (bvashr xlo s) (bvashr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 43))) Bool
 (= (bvashr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 43)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
