(set-logic BV)

(declare-const s (_ BitVec 37))
(declare-const inv_s (_ BitVec 37))
(declare-const t (_ BitVec 37))
(declare-const xlo (_ BitVec 37))
(declare-const xhi (_ BitVec 37))

(define-fun mcb ((xlo (_ BitVec 37)) (xhi (_ BitVec 37)) (v (_ BitVec 37))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 37))) (_ BitVec 37)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (_ bv37 37) (_ bv36 37)) (_ bv35 37)) (_ bv34 37)) (_ bv33 37)) (_ bv32 37)) (_ bv31 37)) (_ bv30 37)) (_ bv29 37)) (_ bv28 37)) (_ bv27 37)) (_ bv26 37)) (_ bv25 37)) (_ bv24 37)) (_ bv23 37)) (_ bv22 37)) (_ bv21 37)) (_ bv20 37)) (_ bv19 37)) (_ bv18 37)) (_ bv17 37)) (_ bv16 37)) (_ bv15 37)) (_ bv14 37)) (_ bv13 37)) (_ bv12 37)) (_ bv11 37)) (_ bv10 37)) (_ bv9 37)) (_ bv8 37)) (_ bv7 37)) (_ bv6 37)) (_ bv5 37)) (_ bv4 37)) (_ bv3 37)) (_ bv2 37)) (_ bv1 37)) (_ bv0 37))
)

(define-fun clz ((v (_ BitVec 37))) (_ BitVec 37)
 (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv37 37) (_ bv36 37)) (_ bv35 37)) (_ bv34 37)) (_ bv33 37)) (_ bv32 37)) (_ bv31 37)) (_ bv30 37)) (_ bv29 37)) (_ bv28 37)) (_ bv27 37)) (_ bv26 37)) (_ bv25 37)) (_ bv24 37)) (_ bv23 37)) (_ bv22 37)) (_ bv21 37)) (_ bv20 37)) (_ bv19 37)) (_ bv18 37)) (_ bv17 37)) (_ bv16 37)) (_ bv15 37)) (_ bv14 37)) (_ bv13 37)) (_ bv12 37)) (_ bv11 37)) (_ bv10 37)) (_ bv9 37)) (_ bv8 37)) (_ bv7 37)) (_ bv6 37)) (_ bv5 37)) (_ bv4 37)) (_ bv3 37)) (_ bv2 37)) (_ bv1 37)) (_ bv0 37))
)

(define-fun cto ((v (_ BitVec 37))) (_ BitVec 37)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 37))) (_ BitVec 37)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 37))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 37)
 (_ bv0 37)
)

(define-fun one () (_ BitVec 37)
 (_ bv1 37)
)

(define-fun ones () (_ BitVec 37)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 37)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 37)
 (bvnot mins)
)

(define-fun w () (_ BitVec 37)
 (_ bv37 37)
)

(define-fun msb ((v (_ BitVec 37))) (_ BitVec 1)
 ((_ extract 36 36) v)
)

(define-fun IC ((s (_ BitVec 37)) (t (_ BitVec 37)) (xlo (_ BitVec 37)) (xhi (_ BitVec 37))) Bool
 (and (distinct s maxs) (or (and (= (msb xlo) #b1) (bvslt s xhi)) (and (distinct (msb xlo) #b1) (bvslt s (bvand maxs xhi)))))
)

(define-fun LIT ((x (_ BitVec 37))) Bool
 (bvslt s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 37)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
