(set-logic BV)

(declare-const s (_ BitVec 59))
(declare-const inv_s (_ BitVec 59))
(declare-const t (_ BitVec 59))
(declare-const xlo (_ BitVec 59))
(declare-const xhi (_ BitVec 59))

(define-fun mcb ((xlo (_ BitVec 59)) (xhi (_ BitVec 59)) (v (_ BitVec 59))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 59))) (_ BitVec 59)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (_ bv59 59) (_ bv58 59)) (_ bv57 59)) (_ bv56 59)) (_ bv55 59)) (_ bv54 59)) (_ bv53 59)) (_ bv52 59)) (_ bv51 59)) (_ bv50 59)) (_ bv49 59)) (_ bv48 59)) (_ bv47 59)) (_ bv46 59)) (_ bv45 59)) (_ bv44 59)) (_ bv43 59)) (_ bv42 59)) (_ bv41 59)) (_ bv40 59)) (_ bv39 59)) (_ bv38 59)) (_ bv37 59)) (_ bv36 59)) (_ bv35 59)) (_ bv34 59)) (_ bv33 59)) (_ bv32 59)) (_ bv31 59)) (_ bv30 59)) (_ bv29 59)) (_ bv28 59)) (_ bv27 59)) (_ bv26 59)) (_ bv25 59)) (_ bv24 59)) (_ bv23 59)) (_ bv22 59)) (_ bv21 59)) (_ bv20 59)) (_ bv19 59)) (_ bv18 59)) (_ bv17 59)) (_ bv16 59)) (_ bv15 59)) (_ bv14 59)) (_ bv13 59)) (_ bv12 59)) (_ bv11 59)) (_ bv10 59)) (_ bv9 59)) (_ bv8 59)) (_ bv7 59)) (_ bv6 59)) (_ bv5 59)) (_ bv4 59)) (_ bv3 59)) (_ bv2 59)) (_ bv1 59)) (_ bv0 59))
)

(define-fun clz ((v (_ BitVec 59))) (_ BitVec 59)
 (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv59 59) (_ bv58 59)) (_ bv57 59)) (_ bv56 59)) (_ bv55 59)) (_ bv54 59)) (_ bv53 59)) (_ bv52 59)) (_ bv51 59)) (_ bv50 59)) (_ bv49 59)) (_ bv48 59)) (_ bv47 59)) (_ bv46 59)) (_ bv45 59)) (_ bv44 59)) (_ bv43 59)) (_ bv42 59)) (_ bv41 59)) (_ bv40 59)) (_ bv39 59)) (_ bv38 59)) (_ bv37 59)) (_ bv36 59)) (_ bv35 59)) (_ bv34 59)) (_ bv33 59)) (_ bv32 59)) (_ bv31 59)) (_ bv30 59)) (_ bv29 59)) (_ bv28 59)) (_ bv27 59)) (_ bv26 59)) (_ bv25 59)) (_ bv24 59)) (_ bv23 59)) (_ bv22 59)) (_ bv21 59)) (_ bv20 59)) (_ bv19 59)) (_ bv18 59)) (_ bv17 59)) (_ bv16 59)) (_ bv15 59)) (_ bv14 59)) (_ bv13 59)) (_ bv12 59)) (_ bv11 59)) (_ bv10 59)) (_ bv9 59)) (_ bv8 59)) (_ bv7 59)) (_ bv6 59)) (_ bv5 59)) (_ bv4 59)) (_ bv3 59)) (_ bv2 59)) (_ bv1 59)) (_ bv0 59))
)

(define-fun cto ((v (_ BitVec 59))) (_ BitVec 59)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 59))) (_ BitVec 59)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 59))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 59)
 (_ bv0 59)
)

(define-fun one () (_ BitVec 59)
 (_ bv1 59)
)

(define-fun ones () (_ BitVec 59)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 59)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 59)
 (bvnot mins)
)

(define-fun w () (_ BitVec 59)
 (_ bv59 59)
)

(define-fun msb ((v (_ BitVec 59))) (_ BitVec 1)
 ((_ extract 58 58) v)
)

(define-fun IC ((s (_ BitVec 59)) (t (_ BitVec 59)) (xlo (_ BitVec 59)) (xhi (_ BitVec 59))) Bool
  (and (distinct s mins) (or (and (= (msb xhi) #b0) (bvslt xlo s)) (and (distinct (msb xhi) #b0) (bvslt (bvor mins xlo) s))))
)

(define-fun LIT ((x (_ BitVec 59))) Bool
 (bvslt x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 59)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
