(set-logic BV)

(declare-const s (_ BitVec 35))
(declare-const inv_s (_ BitVec 35))
(declare-const inv_s_ctz_s (_ BitVec 35))
(declare-const t (_ BitVec 35))
(declare-const xlo (_ BitVec 35))
(declare-const xhi (_ BitVec 35))

(define-fun mcb ((xlo (_ BitVec 35)) (xhi (_ BitVec 35)) (v (_ BitVec 35))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 35))) (_ BitVec 35)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (_ bv35 35) (_ bv34 35)) (_ bv33 35)) (_ bv32 35)) (_ bv31 35)) (_ bv30 35)) (_ bv29 35)) (_ bv28 35)) (_ bv27 35)) (_ bv26 35)) (_ bv25 35)) (_ bv24 35)) (_ bv23 35)) (_ bv22 35)) (_ bv21 35)) (_ bv20 35)) (_ bv19 35)) (_ bv18 35)) (_ bv17 35)) (_ bv16 35)) (_ bv15 35)) (_ bv14 35)) (_ bv13 35)) (_ bv12 35)) (_ bv11 35)) (_ bv10 35)) (_ bv9 35)) (_ bv8 35)) (_ bv7 35)) (_ bv6 35)) (_ bv5 35)) (_ bv4 35)) (_ bv3 35)) (_ bv2 35)) (_ bv1 35)) (_ bv0 35))
)

(define-fun clz ((v (_ BitVec 35))) (_ BitVec 35)
 (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv35 35) (_ bv34 35)) (_ bv33 35)) (_ bv32 35)) (_ bv31 35)) (_ bv30 35)) (_ bv29 35)) (_ bv28 35)) (_ bv27 35)) (_ bv26 35)) (_ bv25 35)) (_ bv24 35)) (_ bv23 35)) (_ bv22 35)) (_ bv21 35)) (_ bv20 35)) (_ bv19 35)) (_ bv18 35)) (_ bv17 35)) (_ bv16 35)) (_ bv15 35)) (_ bv14 35)) (_ bv13 35)) (_ bv12 35)) (_ bv11 35)) (_ bv10 35)) (_ bv9 35)) (_ bv8 35)) (_ bv7 35)) (_ bv6 35)) (_ bv5 35)) (_ bv4 35)) (_ bv3 35)) (_ bv2 35)) (_ bv1 35)) (_ bv0 35))
)

(define-fun cto ((v (_ BitVec 35))) (_ BitVec 35)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 35))) (_ BitVec 35)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 35))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 35)
 (_ bv0 35)
)

(define-fun one () (_ BitVec 35)
 (_ bv1 35)
)

(define-fun ones () (_ BitVec 35)
 (bvnot zero)
)

(define-fun w () (_ BitVec 35)
 (_ bv35 35)
)

(define-fun addo ((a (_ BitVec 35)) (b (_ BitVec 35))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 35 35) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 35)) (b (_ BitVec 35))) Bool
 (let ((zext_a ((_ zero_extend 35) a)) (zext_b ((_ zero_extend 35) b)))
  (distinct
   ((_ extract 34 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 35) (_ bv35 35))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 35)) (t (_ BitVec 35)) (xlo (_ BitVec 35)) (xhi (_ BitVec 35))) Bool
 (and
  (= (bvudiv s (bvudiv s t)) t)
  (and
   (=> (distinct t ones) (bvugt xhi zero))
   (=>
    (or (distinct t zero) (distinct s zero))
    (and
     (bvule (bvudiv s xhi) t)
     (exists ((y (_ BitVec 35)))
      (and
       (mcb xlo xhi y)
       (=> (= t ones) (and (bvuge y zero) (bvule y (bvudiv s t))))
       (=>
        (distinct t ones)
        (and
         (bvugt y (bvudiv s (bvadd t one)))
         (bvule y (bvudiv s t))
        )
       )
      )
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 35))) Bool
 (= (bvudiv s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 35)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

