(set-logic BV)

(declare-const s (_ BitVec 62))
(declare-const inv_s (_ BitVec 62))
(declare-const inv_s_ctz_s (_ BitVec 62))
(declare-const t (_ BitVec 62))
(declare-const xlo (_ BitVec 62))
(declare-const xhi (_ BitVec 62))

(define-fun mcb ((xlo (_ BitVec 62)) (xhi (_ BitVec 62)) (v (_ BitVec 62))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 62))) (_ BitVec 62)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (_ bv62 62) (_ bv61 62)) (_ bv60 62)) (_ bv59 62)) (_ bv58 62)) (_ bv57 62)) (_ bv56 62)) (_ bv55 62)) (_ bv54 62)) (_ bv53 62)) (_ bv52 62)) (_ bv51 62)) (_ bv50 62)) (_ bv49 62)) (_ bv48 62)) (_ bv47 62)) (_ bv46 62)) (_ bv45 62)) (_ bv44 62)) (_ bv43 62)) (_ bv42 62)) (_ bv41 62)) (_ bv40 62)) (_ bv39 62)) (_ bv38 62)) (_ bv37 62)) (_ bv36 62)) (_ bv35 62)) (_ bv34 62)) (_ bv33 62)) (_ bv32 62)) (_ bv31 62)) (_ bv30 62)) (_ bv29 62)) (_ bv28 62)) (_ bv27 62)) (_ bv26 62)) (_ bv25 62)) (_ bv24 62)) (_ bv23 62)) (_ bv22 62)) (_ bv21 62)) (_ bv20 62)) (_ bv19 62)) (_ bv18 62)) (_ bv17 62)) (_ bv16 62)) (_ bv15 62)) (_ bv14 62)) (_ bv13 62)) (_ bv12 62)) (_ bv11 62)) (_ bv10 62)) (_ bv9 62)) (_ bv8 62)) (_ bv7 62)) (_ bv6 62)) (_ bv5 62)) (_ bv4 62)) (_ bv3 62)) (_ bv2 62)) (_ bv1 62)) (_ bv0 62))
)

(define-fun clz ((v (_ BitVec 62))) (_ BitVec 62)
 (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv62 62) (_ bv61 62)) (_ bv60 62)) (_ bv59 62)) (_ bv58 62)) (_ bv57 62)) (_ bv56 62)) (_ bv55 62)) (_ bv54 62)) (_ bv53 62)) (_ bv52 62)) (_ bv51 62)) (_ bv50 62)) (_ bv49 62)) (_ bv48 62)) (_ bv47 62)) (_ bv46 62)) (_ bv45 62)) (_ bv44 62)) (_ bv43 62)) (_ bv42 62)) (_ bv41 62)) (_ bv40 62)) (_ bv39 62)) (_ bv38 62)) (_ bv37 62)) (_ bv36 62)) (_ bv35 62)) (_ bv34 62)) (_ bv33 62)) (_ bv32 62)) (_ bv31 62)) (_ bv30 62)) (_ bv29 62)) (_ bv28 62)) (_ bv27 62)) (_ bv26 62)) (_ bv25 62)) (_ bv24 62)) (_ bv23 62)) (_ bv22 62)) (_ bv21 62)) (_ bv20 62)) (_ bv19 62)) (_ bv18 62)) (_ bv17 62)) (_ bv16 62)) (_ bv15 62)) (_ bv14 62)) (_ bv13 62)) (_ bv12 62)) (_ bv11 62)) (_ bv10 62)) (_ bv9 62)) (_ bv8 62)) (_ bv7 62)) (_ bv6 62)) (_ bv5 62)) (_ bv4 62)) (_ bv3 62)) (_ bv2 62)) (_ bv1 62)) (_ bv0 62))
)

(define-fun cto ((v (_ BitVec 62))) (_ BitVec 62)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 62))) (_ BitVec 62)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 62))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 62)
 (_ bv0 62)
)

(define-fun one () (_ BitVec 62)
 (_ bv1 62)
)

(define-fun ones () (_ BitVec 62)
 (bvnot zero)
)

(define-fun w () (_ BitVec 62)
 (_ bv62 62)
)

(define-fun addo ((a (_ BitVec 62)) (b (_ BitVec 62))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 62 62) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 62)) (b (_ BitVec 62))) Bool
 (let ((zext_a ((_ zero_extend 62) a)) (zext_b ((_ zero_extend 62) b)))
  (distinct
   ((_ extract 61 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 62) (_ bv62 62))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 62)) (t (_ BitVec 62)) (xlo (_ BitVec 62)) (xhi (_ BitVec 62))) Bool
 (and
  (= (bvudiv (bvmul s t) s) t)
  (=>
   (= t zero)
   (bvult xlo s)
  )
  (=>
   (and (distinct t zero) (distinct s zero))
   (exists ((y (_ BitVec 62)))
    (let ((overflow (or (mulo s (bvadd t one)) (addo t one))))
     (and
      (mcb xlo xhi y)
      (=> (not overflow) (bvult y (bvmul s (bvadd t one))))
      (=> overflow (bvule y ones))
      (bvuge y (bvmul s t))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 62))) Bool
 (= (bvudiv x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 62)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

