(set-logic BV)

(declare-const s (_ BitVec 36))
(declare-const inv_s (_ BitVec 36))
(declare-const t (_ BitVec 36))
(declare-const xlo (_ BitVec 36))
(declare-const xhi (_ BitVec 36))

(define-fun mcb ((xlo (_ BitVec 36)) (xhi (_ BitVec 36)) (v (_ BitVec 36))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 36))) (_ BitVec 36)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (_ bv36 36) (_ bv35 36)) (_ bv34 36)) (_ bv33 36)) (_ bv32 36)) (_ bv31 36)) (_ bv30 36)) (_ bv29 36)) (_ bv28 36)) (_ bv27 36)) (_ bv26 36)) (_ bv25 36)) (_ bv24 36)) (_ bv23 36)) (_ bv22 36)) (_ bv21 36)) (_ bv20 36)) (_ bv19 36)) (_ bv18 36)) (_ bv17 36)) (_ bv16 36)) (_ bv15 36)) (_ bv14 36)) (_ bv13 36)) (_ bv12 36)) (_ bv11 36)) (_ bv10 36)) (_ bv9 36)) (_ bv8 36)) (_ bv7 36)) (_ bv6 36)) (_ bv5 36)) (_ bv4 36)) (_ bv3 36)) (_ bv2 36)) (_ bv1 36)) (_ bv0 36))
)

(define-fun clz ((v (_ BitVec 36))) (_ BitVec 36)
 (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv36 36) (_ bv35 36)) (_ bv34 36)) (_ bv33 36)) (_ bv32 36)) (_ bv31 36)) (_ bv30 36)) (_ bv29 36)) (_ bv28 36)) (_ bv27 36)) (_ bv26 36)) (_ bv25 36)) (_ bv24 36)) (_ bv23 36)) (_ bv22 36)) (_ bv21 36)) (_ bv20 36)) (_ bv19 36)) (_ bv18 36)) (_ bv17 36)) (_ bv16 36)) (_ bv15 36)) (_ bv14 36)) (_ bv13 36)) (_ bv12 36)) (_ bv11 36)) (_ bv10 36)) (_ bv9 36)) (_ bv8 36)) (_ bv7 36)) (_ bv6 36)) (_ bv5 36)) (_ bv4 36)) (_ bv3 36)) (_ bv2 36)) (_ bv1 36)) (_ bv0 36))
)

(define-fun cto ((v (_ BitVec 36))) (_ BitVec 36)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 36))) (_ BitVec 36)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 36))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 36)
 (_ bv0 36)
)

(define-fun one () (_ BitVec 36)
 (_ bv1 36)
)

(define-fun ones () (_ BitVec 36)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 36)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 36)
 (bvnot mins)
)

(define-fun w () (_ BitVec 36)
 (_ bv36 36)
)

(define-fun msb ((v (_ BitVec 36))) (_ BitVec 1)
 ((_ extract 35 35) v)
)

(define-fun IC ((s (_ BitVec 36)) (t (_ BitVec 36)) (xlo (_ BitVec 36)) (xhi (_ BitVec 36))) Bool
 (bvuge xhi s)
)

(define-fun LIT ((x (_ BitVec 36))) Bool
 (bvuge x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 36)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
