(set-logic BV)

(declare-const s (_ BitVec 46))
(declare-const inv_s (_ BitVec 46))
(declare-const t (_ BitVec 46))
(declare-const xlo (_ BitVec 46))
(declare-const xhi (_ BitVec 46))

(define-fun mcb ((xlo (_ BitVec 46)) (xhi (_ BitVec 46)) (v (_ BitVec 46))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 46))) (_ BitVec 46)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (_ bv46 46) (_ bv45 46)) (_ bv44 46)) (_ bv43 46)) (_ bv42 46)) (_ bv41 46)) (_ bv40 46)) (_ bv39 46)) (_ bv38 46)) (_ bv37 46)) (_ bv36 46)) (_ bv35 46)) (_ bv34 46)) (_ bv33 46)) (_ bv32 46)) (_ bv31 46)) (_ bv30 46)) (_ bv29 46)) (_ bv28 46)) (_ bv27 46)) (_ bv26 46)) (_ bv25 46)) (_ bv24 46)) (_ bv23 46)) (_ bv22 46)) (_ bv21 46)) (_ bv20 46)) (_ bv19 46)) (_ bv18 46)) (_ bv17 46)) (_ bv16 46)) (_ bv15 46)) (_ bv14 46)) (_ bv13 46)) (_ bv12 46)) (_ bv11 46)) (_ bv10 46)) (_ bv9 46)) (_ bv8 46)) (_ bv7 46)) (_ bv6 46)) (_ bv5 46)) (_ bv4 46)) (_ bv3 46)) (_ bv2 46)) (_ bv1 46)) (_ bv0 46))
)

(define-fun clz ((v (_ BitVec 46))) (_ BitVec 46)
 (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv46 46) (_ bv45 46)) (_ bv44 46)) (_ bv43 46)) (_ bv42 46)) (_ bv41 46)) (_ bv40 46)) (_ bv39 46)) (_ bv38 46)) (_ bv37 46)) (_ bv36 46)) (_ bv35 46)) (_ bv34 46)) (_ bv33 46)) (_ bv32 46)) (_ bv31 46)) (_ bv30 46)) (_ bv29 46)) (_ bv28 46)) (_ bv27 46)) (_ bv26 46)) (_ bv25 46)) (_ bv24 46)) (_ bv23 46)) (_ bv22 46)) (_ bv21 46)) (_ bv20 46)) (_ bv19 46)) (_ bv18 46)) (_ bv17 46)) (_ bv16 46)) (_ bv15 46)) (_ bv14 46)) (_ bv13 46)) (_ bv12 46)) (_ bv11 46)) (_ bv10 46)) (_ bv9 46)) (_ bv8 46)) (_ bv7 46)) (_ bv6 46)) (_ bv5 46)) (_ bv4 46)) (_ bv3 46)) (_ bv2 46)) (_ bv1 46)) (_ bv0 46))
)

(define-fun cto ((v (_ BitVec 46))) (_ BitVec 46)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 46))) (_ BitVec 46)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 46))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 46)
 (_ bv0 46)
)

(define-fun one () (_ BitVec 46)
 (_ bv1 46)
)

(define-fun ones () (_ BitVec 46)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 46)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 46)
 (bvnot mins)
)

(define-fun w () (_ BitVec 46)
 (_ bv46 46)
)

(define-fun msb ((v (_ BitVec 46))) (_ BitVec 1)
 ((_ extract 45 45) v)
)

(define-fun IC ((s (_ BitVec 46)) (t (_ BitVec 46)) (xlo (_ BitVec 46)) (xhi (_ BitVec 46))) Bool
 (and (distinct s ones) (bvugt xhi s))
)

(define-fun LIT ((x (_ BitVec 46))) Bool
 (bvult s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 46)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
