(set-logic BV)

(declare-const s (_ BitVec 53))
(declare-const inv_s (_ BitVec 53))
(declare-const t (_ BitVec 53))
(declare-const xlo (_ BitVec 53))
(declare-const xhi (_ BitVec 53))

(define-fun mcb ((xlo (_ BitVec 53)) (xhi (_ BitVec 53)) (v (_ BitVec 53))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 53))) (_ BitVec 53)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (_ bv53 53) (_ bv52 53)) (_ bv51 53)) (_ bv50 53)) (_ bv49 53)) (_ bv48 53)) (_ bv47 53)) (_ bv46 53)) (_ bv45 53)) (_ bv44 53)) (_ bv43 53)) (_ bv42 53)) (_ bv41 53)) (_ bv40 53)) (_ bv39 53)) (_ bv38 53)) (_ bv37 53)) (_ bv36 53)) (_ bv35 53)) (_ bv34 53)) (_ bv33 53)) (_ bv32 53)) (_ bv31 53)) (_ bv30 53)) (_ bv29 53)) (_ bv28 53)) (_ bv27 53)) (_ bv26 53)) (_ bv25 53)) (_ bv24 53)) (_ bv23 53)) (_ bv22 53)) (_ bv21 53)) (_ bv20 53)) (_ bv19 53)) (_ bv18 53)) (_ bv17 53)) (_ bv16 53)) (_ bv15 53)) (_ bv14 53)) (_ bv13 53)) (_ bv12 53)) (_ bv11 53)) (_ bv10 53)) (_ bv9 53)) (_ bv8 53)) (_ bv7 53)) (_ bv6 53)) (_ bv5 53)) (_ bv4 53)) (_ bv3 53)) (_ bv2 53)) (_ bv1 53)) (_ bv0 53))
)

(define-fun clz ((v (_ BitVec 53))) (_ BitVec 53)
 (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv53 53) (_ bv52 53)) (_ bv51 53)) (_ bv50 53)) (_ bv49 53)) (_ bv48 53)) (_ bv47 53)) (_ bv46 53)) (_ bv45 53)) (_ bv44 53)) (_ bv43 53)) (_ bv42 53)) (_ bv41 53)) (_ bv40 53)) (_ bv39 53)) (_ bv38 53)) (_ bv37 53)) (_ bv36 53)) (_ bv35 53)) (_ bv34 53)) (_ bv33 53)) (_ bv32 53)) (_ bv31 53)) (_ bv30 53)) (_ bv29 53)) (_ bv28 53)) (_ bv27 53)) (_ bv26 53)) (_ bv25 53)) (_ bv24 53)) (_ bv23 53)) (_ bv22 53)) (_ bv21 53)) (_ bv20 53)) (_ bv19 53)) (_ bv18 53)) (_ bv17 53)) (_ bv16 53)) (_ bv15 53)) (_ bv14 53)) (_ bv13 53)) (_ bv12 53)) (_ bv11 53)) (_ bv10 53)) (_ bv9 53)) (_ bv8 53)) (_ bv7 53)) (_ bv6 53)) (_ bv5 53)) (_ bv4 53)) (_ bv3 53)) (_ bv2 53)) (_ bv1 53)) (_ bv0 53))
)

(define-fun cto ((v (_ BitVec 53))) (_ BitVec 53)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 53))) (_ BitVec 53)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 53))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 53)
 (_ bv0 53)
)

(define-fun one () (_ BitVec 53)
 (_ bv1 53)
)

(define-fun ones () (_ BitVec 53)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 53)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 53)
 (bvnot mins)
)

(define-fun w () (_ BitVec 53)
 (_ bv53 53)
)

(define-fun msb ((v (_ BitVec 53))) (_ BitVec 1)
 ((_ extract 52 52) v)
)

(define-fun IC ((s (_ BitVec 53)) (t (_ BitVec 53)) (xlo (_ BitVec 53)) (xhi (_ BitVec 53))) Bool
 (and (distinct s zero) (bvult xlo s))
)

(define-fun LIT ((x (_ BitVec 53))) Bool
 (bvult x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 53)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
