(set-logic BV)

(declare-const s (_ BitVec 34))
(declare-const t (_ BitVec 34))
(declare-const xlo (_ BitVec 34))
(declare-const xhi (_ BitVec 34))

(define-fun mcb ((xlo (_ BitVec 34)) (xhi (_ BitVec 34)) (v (_ BitVec 34))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 34))) (_ BitVec 34)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (_ bv34 34) (_ bv33 34)) (_ bv32 34)) (_ bv31 34)) (_ bv30 34)) (_ bv29 34)) (_ bv28 34)) (_ bv27 34)) (_ bv26 34)) (_ bv25 34)) (_ bv24 34)) (_ bv23 34)) (_ bv22 34)) (_ bv21 34)) (_ bv20 34)) (_ bv19 34)) (_ bv18 34)) (_ bv17 34)) (_ bv16 34)) (_ bv15 34)) (_ bv14 34)) (_ bv13 34)) (_ bv12 34)) (_ bv11 34)) (_ bv10 34)) (_ bv9 34)) (_ bv8 34)) (_ bv7 34)) (_ bv6 34)) (_ bv5 34)) (_ bv4 34)) (_ bv3 34)) (_ bv2 34)) (_ bv1 34)) (_ bv0 34))
)

(define-fun clz ((v (_ BitVec 34))) (_ BitVec 34)
 (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv34 34) (_ bv33 34)) (_ bv32 34)) (_ bv31 34)) (_ bv30 34)) (_ bv29 34)) (_ bv28 34)) (_ bv27 34)) (_ bv26 34)) (_ bv25 34)) (_ bv24 34)) (_ bv23 34)) (_ bv22 34)) (_ bv21 34)) (_ bv20 34)) (_ bv19 34)) (_ bv18 34)) (_ bv17 34)) (_ bv16 34)) (_ bv15 34)) (_ bv14 34)) (_ bv13 34)) (_ bv12 34)) (_ bv11 34)) (_ bv10 34)) (_ bv9 34)) (_ bv8 34)) (_ bv7 34)) (_ bv6 34)) (_ bv5 34)) (_ bv4 34)) (_ bv3 34)) (_ bv2 34)) (_ bv1 34)) (_ bv0 34))
)

(define-fun cto ((v (_ BitVec 34))) (_ BitVec 34)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 34))) (_ BitVec 34)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 34))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 34)
 (_ bv0 34)
)

(define-fun one () (_ BitVec 34)
 (_ bv1 34)
)

(define-fun ones () (_ BitVec 34)
 (bvnot zero)
)

(define-fun w () (_ BitVec 34)
 (_ bv34 34)
)

(define-fun addo ((a (_ BitVec 34)) (b (_ BitVec 34))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 34 34) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 34)) (b (_ BitVec 34))) Bool
 (let ((zext_a ((_ zero_extend 34) a)) (zext_b ((_ zero_extend 34) b)))
  (distinct
   ((_ extract 33 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 34) (_ bv34 34))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 34)) (t (_ BitVec 34)) (xlo (_ BitVec 34)) (xhi (_ BitVec 34))) Bool
 (and
  (bvuge (bvand (bvsub (bvadd t t) s) s) t)
  (=>
   (= s t)
   (or (= xlo zero) (bvugt xhi t))
  )
  (=>
   (distinct s t)
   (exists ((y (_ BitVec 34)))
    (and
     (mcb xlo xhi y)
     (bvugt y t)
     (= (bvurem (bvsub s t) y) zero)
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 34))) Bool
 (= (bvurem s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 34)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

