(set-logic BV)

(declare-const s (_ BitVec 57))
(declare-const tn (_ BitVec 1))
(declare-const tx (_ BitVec 57))
(declare-const xlo (_ BitVec 57))
(declare-const xhi (_ BitVec 57))

(define-fun mcb ((xlo (_ BitVec 57)) (xhi (_ BitVec 57)) (v (_ BitVec 57))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 57))) (_ BitVec 57)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (_ bv57 57) (_ bv56 57)) (_ bv55 57)) (_ bv54 57)) (_ bv53 57)) (_ bv52 57)) (_ bv51 57)) (_ bv50 57)) (_ bv49 57)) (_ bv48 57)) (_ bv47 57)) (_ bv46 57)) (_ bv45 57)) (_ bv44 57)) (_ bv43 57)) (_ bv42 57)) (_ bv41 57)) (_ bv40 57)) (_ bv39 57)) (_ bv38 57)) (_ bv37 57)) (_ bv36 57)) (_ bv35 57)) (_ bv34 57)) (_ bv33 57)) (_ bv32 57)) (_ bv31 57)) (_ bv30 57)) (_ bv29 57)) (_ bv28 57)) (_ bv27 57)) (_ bv26 57)) (_ bv25 57)) (_ bv24 57)) (_ bv23 57)) (_ bv22 57)) (_ bv21 57)) (_ bv20 57)) (_ bv19 57)) (_ bv18 57)) (_ bv17 57)) (_ bv16 57)) (_ bv15 57)) (_ bv14 57)) (_ bv13 57)) (_ bv12 57)) (_ bv11 57)) (_ bv10 57)) (_ bv9 57)) (_ bv8 57)) (_ bv7 57)) (_ bv6 57)) (_ bv5 57)) (_ bv4 57)) (_ bv3 57)) (_ bv2 57)) (_ bv1 57)) (_ bv0 57))
)

(define-fun clz ((v (_ BitVec 57))) (_ BitVec 57)
 (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv57 57) (_ bv56 57)) (_ bv55 57)) (_ bv54 57)) (_ bv53 57)) (_ bv52 57)) (_ bv51 57)) (_ bv50 57)) (_ bv49 57)) (_ bv48 57)) (_ bv47 57)) (_ bv46 57)) (_ bv45 57)) (_ bv44 57)) (_ bv43 57)) (_ bv42 57)) (_ bv41 57)) (_ bv40 57)) (_ bv39 57)) (_ bv38 57)) (_ bv37 57)) (_ bv36 57)) (_ bv35 57)) (_ bv34 57)) (_ bv33 57)) (_ bv32 57)) (_ bv31 57)) (_ bv30 57)) (_ bv29 57)) (_ bv28 57)) (_ bv27 57)) (_ bv26 57)) (_ bv25 57)) (_ bv24 57)) (_ bv23 57)) (_ bv22 57)) (_ bv21 57)) (_ bv20 57)) (_ bv19 57)) (_ bv18 57)) (_ bv17 57)) (_ bv16 57)) (_ bv15 57)) (_ bv14 57)) (_ bv13 57)) (_ bv12 57)) (_ bv11 57)) (_ bv10 57)) (_ bv9 57)) (_ bv8 57)) (_ bv7 57)) (_ bv6 57)) (_ bv5 57)) (_ bv4 57)) (_ bv3 57)) (_ bv2 57)) (_ bv1 57)) (_ bv0 57))
)

(define-fun cto ((v (_ BitVec 57))) (_ BitVec 57)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 57))) (_ BitVec 57)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 57))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 57)
 (_ bv0 57)
)

(define-fun one () (_ BitVec 57)
 (_ bv1 57)
)

(define-fun ones () (_ BitVec 57)
 (bvnot zero)
)

(define-fun w () (_ BitVec 57)
 (_ bv57 57)
)

(define-fun IC ((s (_ BitVec 57)) (tx (_ BitVec 57)) (tn (_ BitVec 1)) (xlo (_ BitVec 57)) (xhi (_ BitVec 57))) Bool
 (and
  (or
   (and (= tn (_ bv0 1)) (= ((_ extract 56 56) tx) #b0))
   (and (= tn (bvnot (_ bv0 1))) (= ((_ extract 56 56) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 57))) Bool
 (= ((_ sign_extend 1) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 57)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
