(set-logic BV)

(declare-const s (_ BitVec 38))
(declare-const tn (_ BitVec 2))
(declare-const tx (_ BitVec 38))
(declare-const xlo (_ BitVec 38))
(declare-const xhi (_ BitVec 38))

(define-fun mcb ((xlo (_ BitVec 38)) (xhi (_ BitVec 38)) (v (_ BitVec 38))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 38))) (_ BitVec 38)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (_ bv38 38) (_ bv37 38)) (_ bv36 38)) (_ bv35 38)) (_ bv34 38)) (_ bv33 38)) (_ bv32 38)) (_ bv31 38)) (_ bv30 38)) (_ bv29 38)) (_ bv28 38)) (_ bv27 38)) (_ bv26 38)) (_ bv25 38)) (_ bv24 38)) (_ bv23 38)) (_ bv22 38)) (_ bv21 38)) (_ bv20 38)) (_ bv19 38)) (_ bv18 38)) (_ bv17 38)) (_ bv16 38)) (_ bv15 38)) (_ bv14 38)) (_ bv13 38)) (_ bv12 38)) (_ bv11 38)) (_ bv10 38)) (_ bv9 38)) (_ bv8 38)) (_ bv7 38)) (_ bv6 38)) (_ bv5 38)) (_ bv4 38)) (_ bv3 38)) (_ bv2 38)) (_ bv1 38)) (_ bv0 38))
)

(define-fun clz ((v (_ BitVec 38))) (_ BitVec 38)
 (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv38 38) (_ bv37 38)) (_ bv36 38)) (_ bv35 38)) (_ bv34 38)) (_ bv33 38)) (_ bv32 38)) (_ bv31 38)) (_ bv30 38)) (_ bv29 38)) (_ bv28 38)) (_ bv27 38)) (_ bv26 38)) (_ bv25 38)) (_ bv24 38)) (_ bv23 38)) (_ bv22 38)) (_ bv21 38)) (_ bv20 38)) (_ bv19 38)) (_ bv18 38)) (_ bv17 38)) (_ bv16 38)) (_ bv15 38)) (_ bv14 38)) (_ bv13 38)) (_ bv12 38)) (_ bv11 38)) (_ bv10 38)) (_ bv9 38)) (_ bv8 38)) (_ bv7 38)) (_ bv6 38)) (_ bv5 38)) (_ bv4 38)) (_ bv3 38)) (_ bv2 38)) (_ bv1 38)) (_ bv0 38))
)

(define-fun cto ((v (_ BitVec 38))) (_ BitVec 38)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 38))) (_ BitVec 38)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 38))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 38)
 (_ bv0 38)
)

(define-fun one () (_ BitVec 38)
 (_ bv1 38)
)

(define-fun ones () (_ BitVec 38)
 (bvnot zero)
)

(define-fun w () (_ BitVec 38)
 (_ bv38 38)
)

(define-fun IC ((s (_ BitVec 38)) (tx (_ BitVec 38)) (tn (_ BitVec 2)) (xlo (_ BitVec 38)) (xhi (_ BitVec 38))) Bool
 (and
  (or
   (and (= tn (_ bv0 2)) (= ((_ extract 37 37) tx) #b0))
   (and (= tn (bvnot (_ bv0 2))) (= ((_ extract 37 37) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 38))) Bool
 (= ((_ sign_extend 2) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 38)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
