(set-logic BV)

(declare-const s (_ BitVec 54))
(declare-const tn (_ BitVec 4))
(declare-const tx (_ BitVec 54))
(declare-const xlo (_ BitVec 54))
(declare-const xhi (_ BitVec 54))

(define-fun mcb ((xlo (_ BitVec 54)) (xhi (_ BitVec 54)) (v (_ BitVec 54))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 54))) (_ BitVec 54)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (_ bv54 54) (_ bv53 54)) (_ bv52 54)) (_ bv51 54)) (_ bv50 54)) (_ bv49 54)) (_ bv48 54)) (_ bv47 54)) (_ bv46 54)) (_ bv45 54)) (_ bv44 54)) (_ bv43 54)) (_ bv42 54)) (_ bv41 54)) (_ bv40 54)) (_ bv39 54)) (_ bv38 54)) (_ bv37 54)) (_ bv36 54)) (_ bv35 54)) (_ bv34 54)) (_ bv33 54)) (_ bv32 54)) (_ bv31 54)) (_ bv30 54)) (_ bv29 54)) (_ bv28 54)) (_ bv27 54)) (_ bv26 54)) (_ bv25 54)) (_ bv24 54)) (_ bv23 54)) (_ bv22 54)) (_ bv21 54)) (_ bv20 54)) (_ bv19 54)) (_ bv18 54)) (_ bv17 54)) (_ bv16 54)) (_ bv15 54)) (_ bv14 54)) (_ bv13 54)) (_ bv12 54)) (_ bv11 54)) (_ bv10 54)) (_ bv9 54)) (_ bv8 54)) (_ bv7 54)) (_ bv6 54)) (_ bv5 54)) (_ bv4 54)) (_ bv3 54)) (_ bv2 54)) (_ bv1 54)) (_ bv0 54))
)

(define-fun clz ((v (_ BitVec 54))) (_ BitVec 54)
 (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv54 54) (_ bv53 54)) (_ bv52 54)) (_ bv51 54)) (_ bv50 54)) (_ bv49 54)) (_ bv48 54)) (_ bv47 54)) (_ bv46 54)) (_ bv45 54)) (_ bv44 54)) (_ bv43 54)) (_ bv42 54)) (_ bv41 54)) (_ bv40 54)) (_ bv39 54)) (_ bv38 54)) (_ bv37 54)) (_ bv36 54)) (_ bv35 54)) (_ bv34 54)) (_ bv33 54)) (_ bv32 54)) (_ bv31 54)) (_ bv30 54)) (_ bv29 54)) (_ bv28 54)) (_ bv27 54)) (_ bv26 54)) (_ bv25 54)) (_ bv24 54)) (_ bv23 54)) (_ bv22 54)) (_ bv21 54)) (_ bv20 54)) (_ bv19 54)) (_ bv18 54)) (_ bv17 54)) (_ bv16 54)) (_ bv15 54)) (_ bv14 54)) (_ bv13 54)) (_ bv12 54)) (_ bv11 54)) (_ bv10 54)) (_ bv9 54)) (_ bv8 54)) (_ bv7 54)) (_ bv6 54)) (_ bv5 54)) (_ bv4 54)) (_ bv3 54)) (_ bv2 54)) (_ bv1 54)) (_ bv0 54))
)

(define-fun cto ((v (_ BitVec 54))) (_ BitVec 54)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 54))) (_ BitVec 54)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 54))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 54)
 (_ bv0 54)
)

(define-fun one () (_ BitVec 54)
 (_ bv1 54)
)

(define-fun ones () (_ BitVec 54)
 (bvnot zero)
)

(define-fun w () (_ BitVec 54)
 (_ bv54 54)
)

(define-fun IC ((s (_ BitVec 54)) (tx (_ BitVec 54)) (tn (_ BitVec 4)) (xlo (_ BitVec 54)) (xhi (_ BitVec 54))) Bool
 (and
  (or
   (and (= tn (_ bv0 4)) (= ((_ extract 53 53) tx) #b0))
   (and (= tn (bvnot (_ bv0 4))) (= ((_ extract 53 53) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 54))) Bool
 (= ((_ sign_extend 4) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 54)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
