(set-logic BV)

(declare-const inv_s (_ BitVec 52))
(declare-const t (_ BitVec 52))
(declare-const xlo (_ BitVec 52))
(declare-const xhi (_ BitVec 52))

(define-fun mcb ((xlo (_ BitVec 52)) (xhi (_ BitVec 52)) (v (_ BitVec 52))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 52))) (_ BitVec 52)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (_ bv52 52) (_ bv51 52)) (_ bv50 52)) (_ bv49 52)) (_ bv48 52)) (_ bv47 52)) (_ bv46 52)) (_ bv45 52)) (_ bv44 52)) (_ bv43 52)) (_ bv42 52)) (_ bv41 52)) (_ bv40 52)) (_ bv39 52)) (_ bv38 52)) (_ bv37 52)) (_ bv36 52)) (_ bv35 52)) (_ bv34 52)) (_ bv33 52)) (_ bv32 52)) (_ bv31 52)) (_ bv30 52)) (_ bv29 52)) (_ bv28 52)) (_ bv27 52)) (_ bv26 52)) (_ bv25 52)) (_ bv24 52)) (_ bv23 52)) (_ bv22 52)) (_ bv21 52)) (_ bv20 52)) (_ bv19 52)) (_ bv18 52)) (_ bv17 52)) (_ bv16 52)) (_ bv15 52)) (_ bv14 52)) (_ bv13 52)) (_ bv12 52)) (_ bv11 52)) (_ bv10 52)) (_ bv9 52)) (_ bv8 52)) (_ bv7 52)) (_ bv6 52)) (_ bv5 52)) (_ bv4 52)) (_ bv3 52)) (_ bv2 52)) (_ bv1 52)) (_ bv0 52))
)

(define-fun clz ((v (_ BitVec 52))) (_ BitVec 52)
 (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv52 52) (_ bv51 52)) (_ bv50 52)) (_ bv49 52)) (_ bv48 52)) (_ bv47 52)) (_ bv46 52)) (_ bv45 52)) (_ bv44 52)) (_ bv43 52)) (_ bv42 52)) (_ bv41 52)) (_ bv40 52)) (_ bv39 52)) (_ bv38 52)) (_ bv37 52)) (_ bv36 52)) (_ bv35 52)) (_ bv34 52)) (_ bv33 52)) (_ bv32 52)) (_ bv31 52)) (_ bv30 52)) (_ bv29 52)) (_ bv28 52)) (_ bv27 52)) (_ bv26 52)) (_ bv25 52)) (_ bv24 52)) (_ bv23 52)) (_ bv22 52)) (_ bv21 52)) (_ bv20 52)) (_ bv19 52)) (_ bv18 52)) (_ bv17 52)) (_ bv16 52)) (_ bv15 52)) (_ bv14 52)) (_ bv13 52)) (_ bv12 52)) (_ bv11 52)) (_ bv10 52)) (_ bv9 52)) (_ bv8 52)) (_ bv7 52)) (_ bv6 52)) (_ bv5 52)) (_ bv4 52)) (_ bv3 52)) (_ bv2 52)) (_ bv1 52)) (_ bv0 52))
)

(define-fun cto ((v (_ BitVec 52))) (_ BitVec 52)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 52))) (_ BitVec 52)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 52))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 52)
 (_ bv0 52)
)

(define-fun one () (_ BitVec 52)
 (_ bv1 52)
)

(define-fun ones () (_ BitVec 52)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 52)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 52)
 (bvnot mins)
)

(define-fun w () (_ BitVec 52)
 (_ bv52 52)
)

(define-fun msb ((v (_ BitVec 52))) (_ BitVec 1)
 ((_ extract 51 51) v)
)

(define-fun CC ((t (_ BitVec 52)) (xlo (_ BitVec 52)) (xhi (_ BitVec 52))) Bool
 (=> (= xlo xhi) (distinct xlo mins))
)

(define-fun LIT ((x (_ BitVec 52)) (s (_ BitVec 52))) Bool
 (bvslt s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 52)) (s (_ BitVec 52)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
