(set-logic BV)

(declare-const inv_s (_ BitVec 51))
(declare-const t (_ BitVec 51))
(declare-const xlo (_ BitVec 51))
(declare-const xhi (_ BitVec 51))

(define-fun mcb ((xlo (_ BitVec 51)) (xhi (_ BitVec 51)) (v (_ BitVec 51))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 51))) (_ BitVec 51)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (_ bv51 51) (_ bv50 51)) (_ bv49 51)) (_ bv48 51)) (_ bv47 51)) (_ bv46 51)) (_ bv45 51)) (_ bv44 51)) (_ bv43 51)) (_ bv42 51)) (_ bv41 51)) (_ bv40 51)) (_ bv39 51)) (_ bv38 51)) (_ bv37 51)) (_ bv36 51)) (_ bv35 51)) (_ bv34 51)) (_ bv33 51)) (_ bv32 51)) (_ bv31 51)) (_ bv30 51)) (_ bv29 51)) (_ bv28 51)) (_ bv27 51)) (_ bv26 51)) (_ bv25 51)) (_ bv24 51)) (_ bv23 51)) (_ bv22 51)) (_ bv21 51)) (_ bv20 51)) (_ bv19 51)) (_ bv18 51)) (_ bv17 51)) (_ bv16 51)) (_ bv15 51)) (_ bv14 51)) (_ bv13 51)) (_ bv12 51)) (_ bv11 51)) (_ bv10 51)) (_ bv9 51)) (_ bv8 51)) (_ bv7 51)) (_ bv6 51)) (_ bv5 51)) (_ bv4 51)) (_ bv3 51)) (_ bv2 51)) (_ bv1 51)) (_ bv0 51))
)

(define-fun clz ((v (_ BitVec 51))) (_ BitVec 51)
 (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv51 51) (_ bv50 51)) (_ bv49 51)) (_ bv48 51)) (_ bv47 51)) (_ bv46 51)) (_ bv45 51)) (_ bv44 51)) (_ bv43 51)) (_ bv42 51)) (_ bv41 51)) (_ bv40 51)) (_ bv39 51)) (_ bv38 51)) (_ bv37 51)) (_ bv36 51)) (_ bv35 51)) (_ bv34 51)) (_ bv33 51)) (_ bv32 51)) (_ bv31 51)) (_ bv30 51)) (_ bv29 51)) (_ bv28 51)) (_ bv27 51)) (_ bv26 51)) (_ bv25 51)) (_ bv24 51)) (_ bv23 51)) (_ bv22 51)) (_ bv21 51)) (_ bv20 51)) (_ bv19 51)) (_ bv18 51)) (_ bv17 51)) (_ bv16 51)) (_ bv15 51)) (_ bv14 51)) (_ bv13 51)) (_ bv12 51)) (_ bv11 51)) (_ bv10 51)) (_ bv9 51)) (_ bv8 51)) (_ bv7 51)) (_ bv6 51)) (_ bv5 51)) (_ bv4 51)) (_ bv3 51)) (_ bv2 51)) (_ bv1 51)) (_ bv0 51))
)

(define-fun cto ((v (_ BitVec 51))) (_ BitVec 51)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 51))) (_ BitVec 51)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 51))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 51)
 (_ bv0 51)
)

(define-fun one () (_ BitVec 51)
 (_ bv1 51)
)

(define-fun ones () (_ BitVec 51)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 51)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 51)
 (bvnot mins)
)

(define-fun w () (_ BitVec 51)
 (_ bv51 51)
)

(define-fun msb ((v (_ BitVec 51))) (_ BitVec 1)
 ((_ extract 50 50) v)
)

(define-fun CC ((t (_ BitVec 51)) (xlo (_ BitVec 51)) (xhi (_ BitVec 51))) Bool
 (=> (= xlo xhi) (distinct xlo maxs))
)

(define-fun LIT ((x (_ BitVec 51)) (s (_ BitVec 51))) Bool
 (bvslt x s)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 51)) (s (_ BitVec 51)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)
