(set-logic BV)

(declare-const tx (_ BitVec 44))
(declare-const ts (_ BitVec 44))
(declare-const xlo (_ BitVec 44))
(declare-const xhi (_ BitVec 44))

(define-fun mcb ((xlo (_ BitVec 44)) (xhi (_ BitVec 44)) (v (_ BitVec 44))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 44))) (_ BitVec 44)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (_ bv44 44) (_ bv43 44)) (_ bv42 44)) (_ bv41 44)) (_ bv40 44)) (_ bv39 44)) (_ bv38 44)) (_ bv37 44)) (_ bv36 44)) (_ bv35 44)) (_ bv34 44)) (_ bv33 44)) (_ bv32 44)) (_ bv31 44)) (_ bv30 44)) (_ bv29 44)) (_ bv28 44)) (_ bv27 44)) (_ bv26 44)) (_ bv25 44)) (_ bv24 44)) (_ bv23 44)) (_ bv22 44)) (_ bv21 44)) (_ bv20 44)) (_ bv19 44)) (_ bv18 44)) (_ bv17 44)) (_ bv16 44)) (_ bv15 44)) (_ bv14 44)) (_ bv13 44)) (_ bv12 44)) (_ bv11 44)) (_ bv10 44)) (_ bv9 44)) (_ bv8 44)) (_ bv7 44)) (_ bv6 44)) (_ bv5 44)) (_ bv4 44)) (_ bv3 44)) (_ bv2 44)) (_ bv1 44)) (_ bv0 44))
)

(define-fun clz ((v (_ BitVec 44))) (_ BitVec 44)
 (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv44 44) (_ bv43 44)) (_ bv42 44)) (_ bv41 44)) (_ bv40 44)) (_ bv39 44)) (_ bv38 44)) (_ bv37 44)) (_ bv36 44)) (_ bv35 44)) (_ bv34 44)) (_ bv33 44)) (_ bv32 44)) (_ bv31 44)) (_ bv30 44)) (_ bv29 44)) (_ bv28 44)) (_ bv27 44)) (_ bv26 44)) (_ bv25 44)) (_ bv24 44)) (_ bv23 44)) (_ bv22 44)) (_ bv21 44)) (_ bv20 44)) (_ bv19 44)) (_ bv18 44)) (_ bv17 44)) (_ bv16 44)) (_ bv15 44)) (_ bv14 44)) (_ bv13 44)) (_ bv12 44)) (_ bv11 44)) (_ bv10 44)) (_ bv9 44)) (_ bv8 44)) (_ bv7 44)) (_ bv6 44)) (_ bv5 44)) (_ bv4 44)) (_ bv3 44)) (_ bv2 44)) (_ bv1 44)) (_ bv0 44))
)

(define-fun cto ((v (_ BitVec 44))) (_ BitVec 44)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 44))) (_ BitVec 44)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 44))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 44)
 (_ bv0 44)
)

(define-fun one () (_ BitVec 44)
 (_ bv1 44)
)

(define-fun ones () (_ BitVec 44)
 (bvnot zero)
)

(define-fun w () (_ BitVec 44)
 (_ bv44 44)
)

(define-fun CC ((tx (_ BitVec 44)) (ts (_ BitVec 44)) (xlo (_ BitVec 44)) (xhi (_ BitVec 44))) Bool
 (mcb xlo xhi tx)
)

(define-fun LIT ((x (_ BitVec 44)) (s (_ BitVec 44))) Bool
 (= (concat x s) (concat tx ts))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC tx ts xlo xhi)
  (exists ((x (_ BitVec 44)) (s (_ BitVec 44)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

