(set-logic BV)

(declare-const inv_s (_ BitVec 49))
(declare-const inv_s_ctz_s (_ BitVec 49))
(declare-const t (_ BitVec 49))
(declare-const xlo (_ BitVec 49))
(declare-const xhi (_ BitVec 49))

(define-fun mcb ((xlo (_ BitVec 49)) (xhi (_ BitVec 49)) (v (_ BitVec 49))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 49))) (_ BitVec 49)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (_ bv49 49) (_ bv48 49)) (_ bv47 49)) (_ bv46 49)) (_ bv45 49)) (_ bv44 49)) (_ bv43 49)) (_ bv42 49)) (_ bv41 49)) (_ bv40 49)) (_ bv39 49)) (_ bv38 49)) (_ bv37 49)) (_ bv36 49)) (_ bv35 49)) (_ bv34 49)) (_ bv33 49)) (_ bv32 49)) (_ bv31 49)) (_ bv30 49)) (_ bv29 49)) (_ bv28 49)) (_ bv27 49)) (_ bv26 49)) (_ bv25 49)) (_ bv24 49)) (_ bv23 49)) (_ bv22 49)) (_ bv21 49)) (_ bv20 49)) (_ bv19 49)) (_ bv18 49)) (_ bv17 49)) (_ bv16 49)) (_ bv15 49)) (_ bv14 49)) (_ bv13 49)) (_ bv12 49)) (_ bv11 49)) (_ bv10 49)) (_ bv9 49)) (_ bv8 49)) (_ bv7 49)) (_ bv6 49)) (_ bv5 49)) (_ bv4 49)) (_ bv3 49)) (_ bv2 49)) (_ bv1 49)) (_ bv0 49))
)

(define-fun clz ((v (_ BitVec 49))) (_ BitVec 49)
 (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv49 49) (_ bv48 49)) (_ bv47 49)) (_ bv46 49)) (_ bv45 49)) (_ bv44 49)) (_ bv43 49)) (_ bv42 49)) (_ bv41 49)) (_ bv40 49)) (_ bv39 49)) (_ bv38 49)) (_ bv37 49)) (_ bv36 49)) (_ bv35 49)) (_ bv34 49)) (_ bv33 49)) (_ bv32 49)) (_ bv31 49)) (_ bv30 49)) (_ bv29 49)) (_ bv28 49)) (_ bv27 49)) (_ bv26 49)) (_ bv25 49)) (_ bv24 49)) (_ bv23 49)) (_ bv22 49)) (_ bv21 49)) (_ bv20 49)) (_ bv19 49)) (_ bv18 49)) (_ bv17 49)) (_ bv16 49)) (_ bv15 49)) (_ bv14 49)) (_ bv13 49)) (_ bv12 49)) (_ bv11 49)) (_ bv10 49)) (_ bv9 49)) (_ bv8 49)) (_ bv7 49)) (_ bv6 49)) (_ bv5 49)) (_ bv4 49)) (_ bv3 49)) (_ bv2 49)) (_ bv1 49)) (_ bv0 49))
)

(define-fun cto ((v (_ BitVec 49))) (_ BitVec 49)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 49))) (_ BitVec 49)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 49))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 49)
 (_ bv0 49)
)

(define-fun one () (_ BitVec 49)
 (_ bv1 49)
)

(define-fun ones () (_ BitVec 49)
 (bvnot zero)
)

(define-fun w () (_ BitVec 49)
 (_ bv49 49)
)

(define-fun addo ((a (_ BitVec 49)) (b (_ BitVec 49))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 49 49) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 49)) (b (_ BitVec 49))) Bool
 (let ((zext_a ((_ zero_extend 49) a)) (zext_b ((_ zero_extend 49) b)))
  (distinct
   ((_ extract 48 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 49) (_ bv49 49))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 49)) (xlo (_ BitVec 49)) (xhi (_ BitVec 49))) Bool
 (and
  (=>
   (= t ones)
   (or
     (mcb xlo xhi zero)
     (mcb xlo xhi one)
   )
  )
  (=>
   (distinct t ones)
   (and
    (not (mulo xlo t))
    (exists ((y (_ BitVec 49)))
     (and
      (mcb xlo xhi y)
      (bvugt y zero)
      (not (mulo y t))
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 49)) (s (_ BitVec 49))) Bool
 (= (bvudiv s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 49)) (s (_ BitVec 49)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

