(set-logic BV)

(declare-const inv_s (_ BitVec 58))
(declare-const inv_s_ctz_s (_ BitVec 58))
(declare-const t (_ BitVec 58))
(declare-const xlo (_ BitVec 58))
(declare-const xhi (_ BitVec 58))

(define-fun mcb ((xlo (_ BitVec 58)) (xhi (_ BitVec 58)) (v (_ BitVec 58))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 58))) (_ BitVec 58)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (_ bv58 58) (_ bv57 58)) (_ bv56 58)) (_ bv55 58)) (_ bv54 58)) (_ bv53 58)) (_ bv52 58)) (_ bv51 58)) (_ bv50 58)) (_ bv49 58)) (_ bv48 58)) (_ bv47 58)) (_ bv46 58)) (_ bv45 58)) (_ bv44 58)) (_ bv43 58)) (_ bv42 58)) (_ bv41 58)) (_ bv40 58)) (_ bv39 58)) (_ bv38 58)) (_ bv37 58)) (_ bv36 58)) (_ bv35 58)) (_ bv34 58)) (_ bv33 58)) (_ bv32 58)) (_ bv31 58)) (_ bv30 58)) (_ bv29 58)) (_ bv28 58)) (_ bv27 58)) (_ bv26 58)) (_ bv25 58)) (_ bv24 58)) (_ bv23 58)) (_ bv22 58)) (_ bv21 58)) (_ bv20 58)) (_ bv19 58)) (_ bv18 58)) (_ bv17 58)) (_ bv16 58)) (_ bv15 58)) (_ bv14 58)) (_ bv13 58)) (_ bv12 58)) (_ bv11 58)) (_ bv10 58)) (_ bv9 58)) (_ bv8 58)) (_ bv7 58)) (_ bv6 58)) (_ bv5 58)) (_ bv4 58)) (_ bv3 58)) (_ bv2 58)) (_ bv1 58)) (_ bv0 58))
)

(define-fun clz ((v (_ BitVec 58))) (_ BitVec 58)
 (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv58 58) (_ bv57 58)) (_ bv56 58)) (_ bv55 58)) (_ bv54 58)) (_ bv53 58)) (_ bv52 58)) (_ bv51 58)) (_ bv50 58)) (_ bv49 58)) (_ bv48 58)) (_ bv47 58)) (_ bv46 58)) (_ bv45 58)) (_ bv44 58)) (_ bv43 58)) (_ bv42 58)) (_ bv41 58)) (_ bv40 58)) (_ bv39 58)) (_ bv38 58)) (_ bv37 58)) (_ bv36 58)) (_ bv35 58)) (_ bv34 58)) (_ bv33 58)) (_ bv32 58)) (_ bv31 58)) (_ bv30 58)) (_ bv29 58)) (_ bv28 58)) (_ bv27 58)) (_ bv26 58)) (_ bv25 58)) (_ bv24 58)) (_ bv23 58)) (_ bv22 58)) (_ bv21 58)) (_ bv20 58)) (_ bv19 58)) (_ bv18 58)) (_ bv17 58)) (_ bv16 58)) (_ bv15 58)) (_ bv14 58)) (_ bv13 58)) (_ bv12 58)) (_ bv11 58)) (_ bv10 58)) (_ bv9 58)) (_ bv8 58)) (_ bv7 58)) (_ bv6 58)) (_ bv5 58)) (_ bv4 58)) (_ bv3 58)) (_ bv2 58)) (_ bv1 58)) (_ bv0 58))
)

(define-fun cto ((v (_ BitVec 58))) (_ BitVec 58)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 58))) (_ BitVec 58)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 58))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 58)
 (_ bv0 58)
)

(define-fun one () (_ BitVec 58)
 (_ bv1 58)
)

(define-fun ones () (_ BitVec 58)
 (bvnot zero)
)

(define-fun w () (_ BitVec 58)
 (_ bv58 58)
)

(define-fun addo ((a (_ BitVec 58)) (b (_ BitVec 58))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 58 58) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 58)) (b (_ BitVec 58))) Bool
 (let ((zext_a ((_ zero_extend 58) a)) (zext_b ((_ zero_extend 58) b)))
  (distinct
   ((_ extract 57 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 58) (_ bv58 58))))
   zero
  )
 )
)

(define-fun CC ((t (_ BitVec 58)) (xlo (_ BitVec 58)) (xhi (_ BitVec 58))) Bool
 (= (bvlshr xlo (bvudiv t xhi)) xlo)
)

(define-fun LIT ((x (_ BitVec 58)) (s (_ BitVec 58))) Bool
 (= (bvurem s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (CC t xlo xhi)
  (exists ((x (_ BitVec 58)) (s (_ BitVec 58)))
   (and
    (mcb xlo xhi x)
    (LIT x s)
   )
  )
 )
)

(check-sat)
(exit)

