(set-logic BV)

(declare-const s (_ BitVec 29))
(declare-const inv_s (_ BitVec 29))
(declare-const t (_ BitVec 29))
(declare-const xlo (_ BitVec 29))
(declare-const xhi (_ BitVec 29))

(define-fun mcb ((xlo (_ BitVec 29)) (xhi (_ BitVec 29)) (v (_ BitVec 29))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 29))) (_ BitVec 29)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (_ bv29 29) (_ bv28 29)) (_ bv27 29)) (_ bv26 29)) (_ bv25 29)) (_ bv24 29)) (_ bv23 29)) (_ bv22 29)) (_ bv21 29)) (_ bv20 29)) (_ bv19 29)) (_ bv18 29)) (_ bv17 29)) (_ bv16 29)) (_ bv15 29)) (_ bv14 29)) (_ bv13 29)) (_ bv12 29)) (_ bv11 29)) (_ bv10 29)) (_ bv9 29)) (_ bv8 29)) (_ bv7 29)) (_ bv6 29)) (_ bv5 29)) (_ bv4 29)) (_ bv3 29)) (_ bv2 29)) (_ bv1 29)) (_ bv0 29))
)

(define-fun clz ((v (_ BitVec 29))) (_ BitVec 29)
 (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv29 29) (_ bv28 29)) (_ bv27 29)) (_ bv26 29)) (_ bv25 29)) (_ bv24 29)) (_ bv23 29)) (_ bv22 29)) (_ bv21 29)) (_ bv20 29)) (_ bv19 29)) (_ bv18 29)) (_ bv17 29)) (_ bv16 29)) (_ bv15 29)) (_ bv14 29)) (_ bv13 29)) (_ bv12 29)) (_ bv11 29)) (_ bv10 29)) (_ bv9 29)) (_ bv8 29)) (_ bv7 29)) (_ bv6 29)) (_ bv5 29)) (_ bv4 29)) (_ bv3 29)) (_ bv2 29)) (_ bv1 29)) (_ bv0 29))
)

(define-fun cto ((v (_ BitVec 29))) (_ BitVec 29)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 29))) (_ BitVec 29)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 29))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 29)
 (_ bv0 29)
)

(define-fun one () (_ BitVec 29)
 (_ bv1 29)
)

(define-fun ones () (_ BitVec 29)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 29)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 29)
 (bvnot mins)
)

(define-fun w () (_ BitVec 29)
 (_ bv29 29)
)

(define-fun msb ((v (_ BitVec 29))) (_ BitVec 1)
 ((_ extract 28 28) v)
)

(define-fun IC ((s (_ BitVec 29)) (t (_ BitVec 29)) (xlo (_ BitVec 29)) (xhi (_ BitVec 29))) Bool
 (mcb xlo xhi (bvsub t s))
)

(define-fun LIT ((x (_ BitVec 29))) Bool
 (= (bvadd x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 29)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
