(set-logic BV)

(declare-const s (_ BitVec 61))
(declare-const inv_s (_ BitVec 61))
(declare-const t (_ BitVec 61))
(declare-const xlo (_ BitVec 61))
(declare-const xhi (_ BitVec 61))

(define-fun mcb ((xlo (_ BitVec 61)) (xhi (_ BitVec 61)) (v (_ BitVec 61))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 61))) (_ BitVec 61)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (_ bv61 61) (_ bv60 61)) (_ bv59 61)) (_ bv58 61)) (_ bv57 61)) (_ bv56 61)) (_ bv55 61)) (_ bv54 61)) (_ bv53 61)) (_ bv52 61)) (_ bv51 61)) (_ bv50 61)) (_ bv49 61)) (_ bv48 61)) (_ bv47 61)) (_ bv46 61)) (_ bv45 61)) (_ bv44 61)) (_ bv43 61)) (_ bv42 61)) (_ bv41 61)) (_ bv40 61)) (_ bv39 61)) (_ bv38 61)) (_ bv37 61)) (_ bv36 61)) (_ bv35 61)) (_ bv34 61)) (_ bv33 61)) (_ bv32 61)) (_ bv31 61)) (_ bv30 61)) (_ bv29 61)) (_ bv28 61)) (_ bv27 61)) (_ bv26 61)) (_ bv25 61)) (_ bv24 61)) (_ bv23 61)) (_ bv22 61)) (_ bv21 61)) (_ bv20 61)) (_ bv19 61)) (_ bv18 61)) (_ bv17 61)) (_ bv16 61)) (_ bv15 61)) (_ bv14 61)) (_ bv13 61)) (_ bv12 61)) (_ bv11 61)) (_ bv10 61)) (_ bv9 61)) (_ bv8 61)) (_ bv7 61)) (_ bv6 61)) (_ bv5 61)) (_ bv4 61)) (_ bv3 61)) (_ bv2 61)) (_ bv1 61)) (_ bv0 61))
)

(define-fun clz ((v (_ BitVec 61))) (_ BitVec 61)
 (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv61 61) (_ bv60 61)) (_ bv59 61)) (_ bv58 61)) (_ bv57 61)) (_ bv56 61)) (_ bv55 61)) (_ bv54 61)) (_ bv53 61)) (_ bv52 61)) (_ bv51 61)) (_ bv50 61)) (_ bv49 61)) (_ bv48 61)) (_ bv47 61)) (_ bv46 61)) (_ bv45 61)) (_ bv44 61)) (_ bv43 61)) (_ bv42 61)) (_ bv41 61)) (_ bv40 61)) (_ bv39 61)) (_ bv38 61)) (_ bv37 61)) (_ bv36 61)) (_ bv35 61)) (_ bv34 61)) (_ bv33 61)) (_ bv32 61)) (_ bv31 61)) (_ bv30 61)) (_ bv29 61)) (_ bv28 61)) (_ bv27 61)) (_ bv26 61)) (_ bv25 61)) (_ bv24 61)) (_ bv23 61)) (_ bv22 61)) (_ bv21 61)) (_ bv20 61)) (_ bv19 61)) (_ bv18 61)) (_ bv17 61)) (_ bv16 61)) (_ bv15 61)) (_ bv14 61)) (_ bv13 61)) (_ bv12 61)) (_ bv11 61)) (_ bv10 61)) (_ bv9 61)) (_ bv8 61)) (_ bv7 61)) (_ bv6 61)) (_ bv5 61)) (_ bv4 61)) (_ bv3 61)) (_ bv2 61)) (_ bv1 61)) (_ bv0 61))
)

(define-fun cto ((v (_ BitVec 61))) (_ BitVec 61)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 61))) (_ BitVec 61)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 61))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 61)
 (_ bv0 61)
)

(define-fun one () (_ BitVec 61)
 (_ bv1 61)
)

(define-fun ones () (_ BitVec 61)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 61)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 61)
 (bvnot mins)
)

(define-fun w () (_ BitVec 61)
 (_ bv61 61)
)

(define-fun msb ((v (_ BitVec 61))) (_ BitVec 1)
 ((_ extract 60 60) v)
)

(define-fun IC ((s (_ BitVec 61)) (t (_ BitVec 61)) (xlo (_ BitVec 61)) (xhi (_ BitVec 61))) Bool
 (and (= (bvand s t) t) (= (bvand s xhi (bvxnor xlo xhi)) (bvand t (bvxnor xlo xhi))))
)

(define-fun LIT ((x (_ BitVec 61))) Bool
 (= (bvand x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 61)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
