(set-logic BV)

(declare-const s (_ BitVec 40))
(declare-const inv_s (_ BitVec 40))
(declare-const t (_ BitVec 40))
(declare-const xlo (_ BitVec 40))
(declare-const xhi (_ BitVec 40))

(define-fun mcb ((xlo (_ BitVec 40)) (xhi (_ BitVec 40)) (v (_ BitVec 40))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 40))) (_ BitVec 40)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (_ bv40 40) (_ bv39 40)) (_ bv38 40)) (_ bv37 40)) (_ bv36 40)) (_ bv35 40)) (_ bv34 40)) (_ bv33 40)) (_ bv32 40)) (_ bv31 40)) (_ bv30 40)) (_ bv29 40)) (_ bv28 40)) (_ bv27 40)) (_ bv26 40)) (_ bv25 40)) (_ bv24 40)) (_ bv23 40)) (_ bv22 40)) (_ bv21 40)) (_ bv20 40)) (_ bv19 40)) (_ bv18 40)) (_ bv17 40)) (_ bv16 40)) (_ bv15 40)) (_ bv14 40)) (_ bv13 40)) (_ bv12 40)) (_ bv11 40)) (_ bv10 40)) (_ bv9 40)) (_ bv8 40)) (_ bv7 40)) (_ bv6 40)) (_ bv5 40)) (_ bv4 40)) (_ bv3 40)) (_ bv2 40)) (_ bv1 40)) (_ bv0 40))
)

(define-fun clz ((v (_ BitVec 40))) (_ BitVec 40)
 (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv40 40) (_ bv39 40)) (_ bv38 40)) (_ bv37 40)) (_ bv36 40)) (_ bv35 40)) (_ bv34 40)) (_ bv33 40)) (_ bv32 40)) (_ bv31 40)) (_ bv30 40)) (_ bv29 40)) (_ bv28 40)) (_ bv27 40)) (_ bv26 40)) (_ bv25 40)) (_ bv24 40)) (_ bv23 40)) (_ bv22 40)) (_ bv21 40)) (_ bv20 40)) (_ bv19 40)) (_ bv18 40)) (_ bv17 40)) (_ bv16 40)) (_ bv15 40)) (_ bv14 40)) (_ bv13 40)) (_ bv12 40)) (_ bv11 40)) (_ bv10 40)) (_ bv9 40)) (_ bv8 40)) (_ bv7 40)) (_ bv6 40)) (_ bv5 40)) (_ bv4 40)) (_ bv3 40)) (_ bv2 40)) (_ bv1 40)) (_ bv0 40))
)

(define-fun cto ((v (_ BitVec 40))) (_ BitVec 40)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 40))) (_ BitVec 40)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 40))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 40)
 (_ bv0 40)
)

(define-fun one () (_ BitVec 40)
 (_ bv1 40)
)

(define-fun ones () (_ BitVec 40)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 40)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 40)
 (bvnot mins)
)

(define-fun w () (_ BitVec 40)
 (_ bv40 40)
)

(define-fun msb ((v (_ BitVec 40))) (_ BitVec 1)
 ((_ extract 39 39) v)
)

(define-fun IC ((s (_ BitVec 40)) (t (_ BitVec 40)) (xlo (_ BitVec 40)) (xhi (_ BitVec 40))) Bool
 (and (=> (bvult s w) (= (bvashr (bvshl t s) s) t)) (=> (bvuge s w) (or (= t ones) (= t zero))) (mcb (bvashr xlo s) (bvashr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 40))) Bool
 (= (bvashr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 40)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
