(set-logic BV)

(declare-const s (_ BitVec 39))
(declare-const inv_s (_ BitVec 39))
(declare-const t (_ BitVec 39))
(declare-const xlo (_ BitVec 39))
(declare-const xhi (_ BitVec 39))

(define-fun mcb ((xlo (_ BitVec 39)) (xhi (_ BitVec 39)) (v (_ BitVec 39))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 39))) (_ BitVec 39)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (_ bv39 39) (_ bv38 39)) (_ bv37 39)) (_ bv36 39)) (_ bv35 39)) (_ bv34 39)) (_ bv33 39)) (_ bv32 39)) (_ bv31 39)) (_ bv30 39)) (_ bv29 39)) (_ bv28 39)) (_ bv27 39)) (_ bv26 39)) (_ bv25 39)) (_ bv24 39)) (_ bv23 39)) (_ bv22 39)) (_ bv21 39)) (_ bv20 39)) (_ bv19 39)) (_ bv18 39)) (_ bv17 39)) (_ bv16 39)) (_ bv15 39)) (_ bv14 39)) (_ bv13 39)) (_ bv12 39)) (_ bv11 39)) (_ bv10 39)) (_ bv9 39)) (_ bv8 39)) (_ bv7 39)) (_ bv6 39)) (_ bv5 39)) (_ bv4 39)) (_ bv3 39)) (_ bv2 39)) (_ bv1 39)) (_ bv0 39))
)

(define-fun clz ((v (_ BitVec 39))) (_ BitVec 39)
 (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv39 39) (_ bv38 39)) (_ bv37 39)) (_ bv36 39)) (_ bv35 39)) (_ bv34 39)) (_ bv33 39)) (_ bv32 39)) (_ bv31 39)) (_ bv30 39)) (_ bv29 39)) (_ bv28 39)) (_ bv27 39)) (_ bv26 39)) (_ bv25 39)) (_ bv24 39)) (_ bv23 39)) (_ bv22 39)) (_ bv21 39)) (_ bv20 39)) (_ bv19 39)) (_ bv18 39)) (_ bv17 39)) (_ bv16 39)) (_ bv15 39)) (_ bv14 39)) (_ bv13 39)) (_ bv12 39)) (_ bv11 39)) (_ bv10 39)) (_ bv9 39)) (_ bv8 39)) (_ bv7 39)) (_ bv6 39)) (_ bv5 39)) (_ bv4 39)) (_ bv3 39)) (_ bv2 39)) (_ bv1 39)) (_ bv0 39))
)

(define-fun cto ((v (_ BitVec 39))) (_ BitVec 39)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 39))) (_ BitVec 39)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 39))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 39)
 (_ bv0 39)
)

(define-fun one () (_ BitVec 39)
 (_ bv1 39)
)

(define-fun ones () (_ BitVec 39)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 39)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 39)
 (bvnot mins)
)

(define-fun w () (_ BitVec 39)
 (_ bv39 39)
)

(define-fun msb ((v (_ BitVec 39))) (_ BitVec 1)
 ((_ extract 38 38) v)
)

(define-fun IC ((s (_ BitVec 39)) (t (_ BitVec 39)) (xlo (_ BitVec 39)) (xhi (_ BitVec 39))) Bool
 (and (= (bvlshr (bvshl t s) s) t) (mcb (bvlshr xlo s) (bvlshr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 39))) Bool
 (= (bvlshr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 39)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
