(set-logic BV)

(declare-const s (_ BitVec 60))
(declare-const inv_s (_ BitVec 60))
(declare-const t (_ BitVec 60))
(declare-const xlo (_ BitVec 60))
(declare-const xhi (_ BitVec 60))

(define-fun mcb ((xlo (_ BitVec 60)) (xhi (_ BitVec 60)) (v (_ BitVec 60))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 60))) (_ BitVec 60)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (_ bv60 60) (_ bv59 60)) (_ bv58 60)) (_ bv57 60)) (_ bv56 60)) (_ bv55 60)) (_ bv54 60)) (_ bv53 60)) (_ bv52 60)) (_ bv51 60)) (_ bv50 60)) (_ bv49 60)) (_ bv48 60)) (_ bv47 60)) (_ bv46 60)) (_ bv45 60)) (_ bv44 60)) (_ bv43 60)) (_ bv42 60)) (_ bv41 60)) (_ bv40 60)) (_ bv39 60)) (_ bv38 60)) (_ bv37 60)) (_ bv36 60)) (_ bv35 60)) (_ bv34 60)) (_ bv33 60)) (_ bv32 60)) (_ bv31 60)) (_ bv30 60)) (_ bv29 60)) (_ bv28 60)) (_ bv27 60)) (_ bv26 60)) (_ bv25 60)) (_ bv24 60)) (_ bv23 60)) (_ bv22 60)) (_ bv21 60)) (_ bv20 60)) (_ bv19 60)) (_ bv18 60)) (_ bv17 60)) (_ bv16 60)) (_ bv15 60)) (_ bv14 60)) (_ bv13 60)) (_ bv12 60)) (_ bv11 60)) (_ bv10 60)) (_ bv9 60)) (_ bv8 60)) (_ bv7 60)) (_ bv6 60)) (_ bv5 60)) (_ bv4 60)) (_ bv3 60)) (_ bv2 60)) (_ bv1 60)) (_ bv0 60))
)

(define-fun clz ((v (_ BitVec 60))) (_ BitVec 60)
 (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv60 60) (_ bv59 60)) (_ bv58 60)) (_ bv57 60)) (_ bv56 60)) (_ bv55 60)) (_ bv54 60)) (_ bv53 60)) (_ bv52 60)) (_ bv51 60)) (_ bv50 60)) (_ bv49 60)) (_ bv48 60)) (_ bv47 60)) (_ bv46 60)) (_ bv45 60)) (_ bv44 60)) (_ bv43 60)) (_ bv42 60)) (_ bv41 60)) (_ bv40 60)) (_ bv39 60)) (_ bv38 60)) (_ bv37 60)) (_ bv36 60)) (_ bv35 60)) (_ bv34 60)) (_ bv33 60)) (_ bv32 60)) (_ bv31 60)) (_ bv30 60)) (_ bv29 60)) (_ bv28 60)) (_ bv27 60)) (_ bv26 60)) (_ bv25 60)) (_ bv24 60)) (_ bv23 60)) (_ bv22 60)) (_ bv21 60)) (_ bv20 60)) (_ bv19 60)) (_ bv18 60)) (_ bv17 60)) (_ bv16 60)) (_ bv15 60)) (_ bv14 60)) (_ bv13 60)) (_ bv12 60)) (_ bv11 60)) (_ bv10 60)) (_ bv9 60)) (_ bv8 60)) (_ bv7 60)) (_ bv6 60)) (_ bv5 60)) (_ bv4 60)) (_ bv3 60)) (_ bv2 60)) (_ bv1 60)) (_ bv0 60))
)

(define-fun cto ((v (_ BitVec 60))) (_ BitVec 60)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 60))) (_ BitVec 60)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 60))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 60)
 (_ bv0 60)
)

(define-fun one () (_ BitVec 60)
 (_ bv1 60)
)

(define-fun ones () (_ BitVec 60)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 60)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 60)
 (bvnot mins)
)

(define-fun w () (_ BitVec 60)
 (_ bv60 60)
)

(define-fun msb ((v (_ BitVec 60))) (_ BitVec 1)
 ((_ extract 59 59) v)
)

(define-fun IC ((s (_ BitVec 60)) (t (_ BitVec 60)) (xlo (_ BitVec 60)) (xhi (_ BitVec 60))) Bool
 (and (= (bvlshr (bvshl t s) s) t) (mcb (bvlshr xlo s) (bvlshr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 60))) Bool
 (= (bvlshr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 60)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
