(set-logic BV)

(declare-const s (_ BitVec 65))
(declare-const inv_s (_ BitVec 65))
(declare-const t (_ BitVec 65))
(declare-const xlo (_ BitVec 65))
(declare-const xhi (_ BitVec 65))

(define-fun mcb ((xlo (_ BitVec 65)) (xhi (_ BitVec 65)) (v (_ BitVec 65))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 65))) (_ BitVec 65)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 62 62) v) #b0) (ite (= ((_ extract 63 63) v) #b0) (ite (= ((_ extract 64 64) v) #b0) (_ bv65 65) (_ bv64 65)) (_ bv63 65)) (_ bv62 65)) (_ bv61 65)) (_ bv60 65)) (_ bv59 65)) (_ bv58 65)) (_ bv57 65)) (_ bv56 65)) (_ bv55 65)) (_ bv54 65)) (_ bv53 65)) (_ bv52 65)) (_ bv51 65)) (_ bv50 65)) (_ bv49 65)) (_ bv48 65)) (_ bv47 65)) (_ bv46 65)) (_ bv45 65)) (_ bv44 65)) (_ bv43 65)) (_ bv42 65)) (_ bv41 65)) (_ bv40 65)) (_ bv39 65)) (_ bv38 65)) (_ bv37 65)) (_ bv36 65)) (_ bv35 65)) (_ bv34 65)) (_ bv33 65)) (_ bv32 65)) (_ bv31 65)) (_ bv30 65)) (_ bv29 65)) (_ bv28 65)) (_ bv27 65)) (_ bv26 65)) (_ bv25 65)) (_ bv24 65)) (_ bv23 65)) (_ bv22 65)) (_ bv21 65)) (_ bv20 65)) (_ bv19 65)) (_ bv18 65)) (_ bv17 65)) (_ bv16 65)) (_ bv15 65)) (_ bv14 65)) (_ bv13 65)) (_ bv12 65)) (_ bv11 65)) (_ bv10 65)) (_ bv9 65)) (_ bv8 65)) (_ bv7 65)) (_ bv6 65)) (_ bv5 65)) (_ bv4 65)) (_ bv3 65)) (_ bv2 65)) (_ bv1 65)) (_ bv0 65))
)

(define-fun clz ((v (_ BitVec 65))) (_ BitVec 65)
 (ite (= ((_ extract 64 64) v) #b0) (ite (= ((_ extract 63 63) v) #b0) (ite (= ((_ extract 62 62) v) #b0) (ite (= ((_ extract 61 61) v) #b0) (ite (= ((_ extract 60 60) v) #b0) (ite (= ((_ extract 59 59) v) #b0) (ite (= ((_ extract 58 58) v) #b0) (ite (= ((_ extract 57 57) v) #b0) (ite (= ((_ extract 56 56) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv65 65) (_ bv64 65)) (_ bv63 65)) (_ bv62 65)) (_ bv61 65)) (_ bv60 65)) (_ bv59 65)) (_ bv58 65)) (_ bv57 65)) (_ bv56 65)) (_ bv55 65)) (_ bv54 65)) (_ bv53 65)) (_ bv52 65)) (_ bv51 65)) (_ bv50 65)) (_ bv49 65)) (_ bv48 65)) (_ bv47 65)) (_ bv46 65)) (_ bv45 65)) (_ bv44 65)) (_ bv43 65)) (_ bv42 65)) (_ bv41 65)) (_ bv40 65)) (_ bv39 65)) (_ bv38 65)) (_ bv37 65)) (_ bv36 65)) (_ bv35 65)) (_ bv34 65)) (_ bv33 65)) (_ bv32 65)) (_ bv31 65)) (_ bv30 65)) (_ bv29 65)) (_ bv28 65)) (_ bv27 65)) (_ bv26 65)) (_ bv25 65)) (_ bv24 65)) (_ bv23 65)) (_ bv22 65)) (_ bv21 65)) (_ bv20 65)) (_ bv19 65)) (_ bv18 65)) (_ bv17 65)) (_ bv16 65)) (_ bv15 65)) (_ bv14 65)) (_ bv13 65)) (_ bv12 65)) (_ bv11 65)) (_ bv10 65)) (_ bv9 65)) (_ bv8 65)) (_ bv7 65)) (_ bv6 65)) (_ bv5 65)) (_ bv4 65)) (_ bv3 65)) (_ bv2 65)) (_ bv1 65)) (_ bv0 65))
)

(define-fun cto ((v (_ BitVec 65))) (_ BitVec 65)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 65))) (_ BitVec 65)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 65))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 65)
 (_ bv0 65)
)

(define-fun one () (_ BitVec 65)
 (_ bv1 65)
)

(define-fun ones () (_ BitVec 65)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 65)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 65)
 (bvnot mins)
)

(define-fun w () (_ BitVec 65)
 (_ bv65 65)
)

(define-fun msb ((v (_ BitVec 65))) (_ BitVec 1)
 ((_ extract 64 64) v)
)

(define-fun IC ((s (_ BitVec 65)) (t (_ BitVec 65)) (xlo (_ BitVec 65)) (xhi (_ BitVec 65))) Bool
 (and (= (bvlshr (bvshl t s) s) t) (mcb (bvlshr xlo s) (bvlshr xhi s) t))
)

(define-fun LIT ((x (_ BitVec 65))) Bool
 (= (bvlshr x s) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 65)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
