(set-logic BV)

(declare-const s (_ BitVec 45))
(declare-const inv_s (_ BitVec 45))
(declare-const t (_ BitVec 45))
(declare-const xlo (_ BitVec 45))
(declare-const xhi (_ BitVec 45))

(define-fun mcb ((xlo (_ BitVec 45)) (xhi (_ BitVec 45)) (v (_ BitVec 45))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 45))) (_ BitVec 45)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (_ bv45 45) (_ bv44 45)) (_ bv43 45)) (_ bv42 45)) (_ bv41 45)) (_ bv40 45)) (_ bv39 45)) (_ bv38 45)) (_ bv37 45)) (_ bv36 45)) (_ bv35 45)) (_ bv34 45)) (_ bv33 45)) (_ bv32 45)) (_ bv31 45)) (_ bv30 45)) (_ bv29 45)) (_ bv28 45)) (_ bv27 45)) (_ bv26 45)) (_ bv25 45)) (_ bv24 45)) (_ bv23 45)) (_ bv22 45)) (_ bv21 45)) (_ bv20 45)) (_ bv19 45)) (_ bv18 45)) (_ bv17 45)) (_ bv16 45)) (_ bv15 45)) (_ bv14 45)) (_ bv13 45)) (_ bv12 45)) (_ bv11 45)) (_ bv10 45)) (_ bv9 45)) (_ bv8 45)) (_ bv7 45)) (_ bv6 45)) (_ bv5 45)) (_ bv4 45)) (_ bv3 45)) (_ bv2 45)) (_ bv1 45)) (_ bv0 45))
)

(define-fun clz ((v (_ BitVec 45))) (_ BitVec 45)
 (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv45 45) (_ bv44 45)) (_ bv43 45)) (_ bv42 45)) (_ bv41 45)) (_ bv40 45)) (_ bv39 45)) (_ bv38 45)) (_ bv37 45)) (_ bv36 45)) (_ bv35 45)) (_ bv34 45)) (_ bv33 45)) (_ bv32 45)) (_ bv31 45)) (_ bv30 45)) (_ bv29 45)) (_ bv28 45)) (_ bv27 45)) (_ bv26 45)) (_ bv25 45)) (_ bv24 45)) (_ bv23 45)) (_ bv22 45)) (_ bv21 45)) (_ bv20 45)) (_ bv19 45)) (_ bv18 45)) (_ bv17 45)) (_ bv16 45)) (_ bv15 45)) (_ bv14 45)) (_ bv13 45)) (_ bv12 45)) (_ bv11 45)) (_ bv10 45)) (_ bv9 45)) (_ bv8 45)) (_ bv7 45)) (_ bv6 45)) (_ bv5 45)) (_ bv4 45)) (_ bv3 45)) (_ bv2 45)) (_ bv1 45)) (_ bv0 45))
)

(define-fun cto ((v (_ BitVec 45))) (_ BitVec 45)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 45))) (_ BitVec 45)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 45))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 45)
 (_ bv0 45)
)

(define-fun one () (_ BitVec 45)
 (_ bv1 45)
)

(define-fun ones () (_ BitVec 45)
 (bvnot zero)
)

(define-fun mins () (_ BitVec 45)
 (bvnot (bvlshr ones one))
)

(define-fun maxs () (_ BitVec 45)
 (bvnot mins)
)

(define-fun w () (_ BitVec 45)
 (_ bv45 45)
)

(define-fun msb ((v (_ BitVec 45))) (_ BitVec 1)
 ((_ extract 44 44) v)
)

(define-fun IC ((s (_ BitVec 45)) (t (_ BitVec 45)) (xlo (_ BitVec 45)) (xhi (_ BitVec 45))) Bool
 (or (and (= (msb xhi) #b0) (bvsge s xlo)) (and (distinct (msb xhi) #b0) (bvsge s (bvor mins xlo))))
)

(define-fun LIT ((x (_ BitVec 45))) Bool
 (bvsge s x)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 45)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
