(set-logic BV)

(declare-const s (_ BitVec 56))
(declare-const inv_s (_ BitVec 56))
(declare-const inv_s_ctz_s (_ BitVec 56))
(declare-const t (_ BitVec 56))
(declare-const xlo (_ BitVec 56))
(declare-const xhi (_ BitVec 56))

(define-fun mcb ((xlo (_ BitVec 56)) (xhi (_ BitVec 56)) (v (_ BitVec 56))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 56))) (_ BitVec 56)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 55 55) v) #b0) (_ bv56 56) (_ bv55 56)) (_ bv54 56)) (_ bv53 56)) (_ bv52 56)) (_ bv51 56)) (_ bv50 56)) (_ bv49 56)) (_ bv48 56)) (_ bv47 56)) (_ bv46 56)) (_ bv45 56)) (_ bv44 56)) (_ bv43 56)) (_ bv42 56)) (_ bv41 56)) (_ bv40 56)) (_ bv39 56)) (_ bv38 56)) (_ bv37 56)) (_ bv36 56)) (_ bv35 56)) (_ bv34 56)) (_ bv33 56)) (_ bv32 56)) (_ bv31 56)) (_ bv30 56)) (_ bv29 56)) (_ bv28 56)) (_ bv27 56)) (_ bv26 56)) (_ bv25 56)) (_ bv24 56)) (_ bv23 56)) (_ bv22 56)) (_ bv21 56)) (_ bv20 56)) (_ bv19 56)) (_ bv18 56)) (_ bv17 56)) (_ bv16 56)) (_ bv15 56)) (_ bv14 56)) (_ bv13 56)) (_ bv12 56)) (_ bv11 56)) (_ bv10 56)) (_ bv9 56)) (_ bv8 56)) (_ bv7 56)) (_ bv6 56)) (_ bv5 56)) (_ bv4 56)) (_ bv3 56)) (_ bv2 56)) (_ bv1 56)) (_ bv0 56))
)

(define-fun clz ((v (_ BitVec 56))) (_ BitVec 56)
 (ite (= ((_ extract 55 55) v) #b0) (ite (= ((_ extract 54 54) v) #b0) (ite (= ((_ extract 53 53) v) #b0) (ite (= ((_ extract 52 52) v) #b0) (ite (= ((_ extract 51 51) v) #b0) (ite (= ((_ extract 50 50) v) #b0) (ite (= ((_ extract 49 49) v) #b0) (ite (= ((_ extract 48 48) v) #b0) (ite (= ((_ extract 47 47) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv56 56) (_ bv55 56)) (_ bv54 56)) (_ bv53 56)) (_ bv52 56)) (_ bv51 56)) (_ bv50 56)) (_ bv49 56)) (_ bv48 56)) (_ bv47 56)) (_ bv46 56)) (_ bv45 56)) (_ bv44 56)) (_ bv43 56)) (_ bv42 56)) (_ bv41 56)) (_ bv40 56)) (_ bv39 56)) (_ bv38 56)) (_ bv37 56)) (_ bv36 56)) (_ bv35 56)) (_ bv34 56)) (_ bv33 56)) (_ bv32 56)) (_ bv31 56)) (_ bv30 56)) (_ bv29 56)) (_ bv28 56)) (_ bv27 56)) (_ bv26 56)) (_ bv25 56)) (_ bv24 56)) (_ bv23 56)) (_ bv22 56)) (_ bv21 56)) (_ bv20 56)) (_ bv19 56)) (_ bv18 56)) (_ bv17 56)) (_ bv16 56)) (_ bv15 56)) (_ bv14 56)) (_ bv13 56)) (_ bv12 56)) (_ bv11 56)) (_ bv10 56)) (_ bv9 56)) (_ bv8 56)) (_ bv7 56)) (_ bv6 56)) (_ bv5 56)) (_ bv4 56)) (_ bv3 56)) (_ bv2 56)) (_ bv1 56)) (_ bv0 56))
)

(define-fun cto ((v (_ BitVec 56))) (_ BitVec 56)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 56))) (_ BitVec 56)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 56))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 56)
 (_ bv0 56)
)

(define-fun one () (_ BitVec 56)
 (_ bv1 56)
)

(define-fun ones () (_ BitVec 56)
 (bvnot zero)
)

(define-fun w () (_ BitVec 56)
 (_ bv56 56)
)

(define-fun addo ((a (_ BitVec 56)) (b (_ BitVec 56))) Bool
 (let ((zext_a ((_ zero_extend 1) a)) (zext_b ((_ zero_extend 1) b)))
  (= ((_ extract 56 56) (bvadd zext_a zext_b)) #b1)
 )
)

(define-fun mulo ((a (_ BitVec 56)) (b (_ BitVec 56))) Bool
 (let ((zext_a ((_ zero_extend 56) a)) (zext_b ((_ zero_extend 56) b)))
  (distinct
   ((_ extract 55 0) (bvlshr (bvmul zext_a zext_b) ((_ zero_extend 56) (_ bv56 56))))
   zero
  )
 )
)

(define-fun IC ((s (_ BitVec 56)) (t (_ BitVec 56)) (xlo (_ BitVec 56)) (xhi (_ BitVec 56))) Bool
 (and
  (= (bvudiv s (bvudiv s t)) t)
  (and
   (=> (distinct t ones) (bvugt xhi zero))
   (=>
    (or (distinct t zero) (distinct s zero))
    (and
     (bvule (bvudiv s xhi) t)
     (exists ((y (_ BitVec 56)))
      (and
       (mcb xlo xhi y)
       (=> (= t ones) (and (bvuge y zero) (bvule y (bvudiv s t))))
       (=>
        (distinct t ones)
        (and
         (bvugt y (bvudiv s (bvadd t one)))
         (bvule y (bvudiv s t))
        )
       )
      )
     )
    )
   )
  )
 )
)

(define-fun LIT ((x (_ BitVec 56))) Bool
 (= (bvudiv s x) t)
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s t xlo xhi)
  (exists ((x (_ BitVec 56)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)

