(set-logic BV)

(declare-const s (_ BitVec 47))
(declare-const tn (_ BitVec 1))
(declare-const tx (_ BitVec 47))
(declare-const xlo (_ BitVec 47))
(declare-const xhi (_ BitVec 47))

(define-fun mcb ((xlo (_ BitVec 47)) (xhi (_ BitVec 47)) (v (_ BitVec 47))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 47))) (_ BitVec 47)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 46 46) v) #b0) (_ bv47 47) (_ bv46 47)) (_ bv45 47)) (_ bv44 47)) (_ bv43 47)) (_ bv42 47)) (_ bv41 47)) (_ bv40 47)) (_ bv39 47)) (_ bv38 47)) (_ bv37 47)) (_ bv36 47)) (_ bv35 47)) (_ bv34 47)) (_ bv33 47)) (_ bv32 47)) (_ bv31 47)) (_ bv30 47)) (_ bv29 47)) (_ bv28 47)) (_ bv27 47)) (_ bv26 47)) (_ bv25 47)) (_ bv24 47)) (_ bv23 47)) (_ bv22 47)) (_ bv21 47)) (_ bv20 47)) (_ bv19 47)) (_ bv18 47)) (_ bv17 47)) (_ bv16 47)) (_ bv15 47)) (_ bv14 47)) (_ bv13 47)) (_ bv12 47)) (_ bv11 47)) (_ bv10 47)) (_ bv9 47)) (_ bv8 47)) (_ bv7 47)) (_ bv6 47)) (_ bv5 47)) (_ bv4 47)) (_ bv3 47)) (_ bv2 47)) (_ bv1 47)) (_ bv0 47))
)

(define-fun clz ((v (_ BitVec 47))) (_ BitVec 47)
 (ite (= ((_ extract 46 46) v) #b0) (ite (= ((_ extract 45 45) v) #b0) (ite (= ((_ extract 44 44) v) #b0) (ite (= ((_ extract 43 43) v) #b0) (ite (= ((_ extract 42 42) v) #b0) (ite (= ((_ extract 41 41) v) #b0) (ite (= ((_ extract 40 40) v) #b0) (ite (= ((_ extract 39 39) v) #b0) (ite (= ((_ extract 38 38) v) #b0) (ite (= ((_ extract 37 37) v) #b0) (ite (= ((_ extract 36 36) v) #b0) (ite (= ((_ extract 35 35) v) #b0) (ite (= ((_ extract 34 34) v) #b0) (ite (= ((_ extract 33 33) v) #b0) (ite (= ((_ extract 32 32) v) #b0) (ite (= ((_ extract 31 31) v) #b0) (ite (= ((_ extract 30 30) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv47 47) (_ bv46 47)) (_ bv45 47)) (_ bv44 47)) (_ bv43 47)) (_ bv42 47)) (_ bv41 47)) (_ bv40 47)) (_ bv39 47)) (_ bv38 47)) (_ bv37 47)) (_ bv36 47)) (_ bv35 47)) (_ bv34 47)) (_ bv33 47)) (_ bv32 47)) (_ bv31 47)) (_ bv30 47)) (_ bv29 47)) (_ bv28 47)) (_ bv27 47)) (_ bv26 47)) (_ bv25 47)) (_ bv24 47)) (_ bv23 47)) (_ bv22 47)) (_ bv21 47)) (_ bv20 47)) (_ bv19 47)) (_ bv18 47)) (_ bv17 47)) (_ bv16 47)) (_ bv15 47)) (_ bv14 47)) (_ bv13 47)) (_ bv12 47)) (_ bv11 47)) (_ bv10 47)) (_ bv9 47)) (_ bv8 47)) (_ bv7 47)) (_ bv6 47)) (_ bv5 47)) (_ bv4 47)) (_ bv3 47)) (_ bv2 47)) (_ bv1 47)) (_ bv0 47))
)

(define-fun cto ((v (_ BitVec 47))) (_ BitVec 47)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 47))) (_ BitVec 47)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 47))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 47)
 (_ bv0 47)
)

(define-fun one () (_ BitVec 47)
 (_ bv1 47)
)

(define-fun ones () (_ BitVec 47)
 (bvnot zero)
)

(define-fun w () (_ BitVec 47)
 (_ bv47 47)
)

(define-fun IC ((s (_ BitVec 47)) (tx (_ BitVec 47)) (tn (_ BitVec 1)) (xlo (_ BitVec 47)) (xhi (_ BitVec 47))) Bool
 (and
  (or
   (and (= tn (_ bv0 1)) (= ((_ extract 46 46) tx) #b0))
   (and (= tn (bvnot (_ bv0 1))) (= ((_ extract 46 46) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 47))) Bool
 (= ((_ sign_extend 1) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 47)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
