(set-logic BV)

(declare-const s (_ BitVec 30))
(declare-const tn (_ BitVec 4))
(declare-const tx (_ BitVec 30))
(declare-const xlo (_ BitVec 30))
(declare-const xhi (_ BitVec 30))

(define-fun mcb ((xlo (_ BitVec 30)) (xhi (_ BitVec 30)) (v (_ BitVec 30))) Bool
 (and
  (= (bvand xhi v) v)
  (= (bvor xlo v) v)
 )
)

(define-fun ctz ((v (_ BitVec 30))) (_ BitVec 30)
 (ite (= ((_ extract 0 0) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 29 29) v) #b0) (_ bv30 30) (_ bv29 30)) (_ bv28 30)) (_ bv27 30)) (_ bv26 30)) (_ bv25 30)) (_ bv24 30)) (_ bv23 30)) (_ bv22 30)) (_ bv21 30)) (_ bv20 30)) (_ bv19 30)) (_ bv18 30)) (_ bv17 30)) (_ bv16 30)) (_ bv15 30)) (_ bv14 30)) (_ bv13 30)) (_ bv12 30)) (_ bv11 30)) (_ bv10 30)) (_ bv9 30)) (_ bv8 30)) (_ bv7 30)) (_ bv6 30)) (_ bv5 30)) (_ bv4 30)) (_ bv3 30)) (_ bv2 30)) (_ bv1 30)) (_ bv0 30))
)

(define-fun clz ((v (_ BitVec 30))) (_ BitVec 30)
 (ite (= ((_ extract 29 29) v) #b0) (ite (= ((_ extract 28 28) v) #b0) (ite (= ((_ extract 27 27) v) #b0) (ite (= ((_ extract 26 26) v) #b0) (ite (= ((_ extract 25 25) v) #b0) (ite (= ((_ extract 24 24) v) #b0) (ite (= ((_ extract 23 23) v) #b0) (ite (= ((_ extract 22 22) v) #b0) (ite (= ((_ extract 21 21) v) #b0) (ite (= ((_ extract 20 20) v) #b0) (ite (= ((_ extract 19 19) v) #b0) (ite (= ((_ extract 18 18) v) #b0) (ite (= ((_ extract 17 17) v) #b0) (ite (= ((_ extract 16 16) v) #b0) (ite (= ((_ extract 15 15) v) #b0) (ite (= ((_ extract 14 14) v) #b0) (ite (= ((_ extract 13 13) v) #b0) (ite (= ((_ extract 12 12) v) #b0) (ite (= ((_ extract 11 11) v) #b0) (ite (= ((_ extract 10 10) v) #b0) (ite (= ((_ extract 9 9) v) #b0) (ite (= ((_ extract 8 8) v) #b0) (ite (= ((_ extract 7 7) v) #b0) (ite (= ((_ extract 6 6) v) #b0) (ite (= ((_ extract 5 5) v) #b0) (ite (= ((_ extract 4 4) v) #b0) (ite (= ((_ extract 3 3) v) #b0) (ite (= ((_ extract 2 2) v) #b0) (ite (= ((_ extract 1 1) v) #b0) (ite (= ((_ extract 0 0) v) #b0) (_ bv30 30) (_ bv29 30)) (_ bv28 30)) (_ bv27 30)) (_ bv26 30)) (_ bv25 30)) (_ bv24 30)) (_ bv23 30)) (_ bv22 30)) (_ bv21 30)) (_ bv20 30)) (_ bv19 30)) (_ bv18 30)) (_ bv17 30)) (_ bv16 30)) (_ bv15 30)) (_ bv14 30)) (_ bv13 30)) (_ bv12 30)) (_ bv11 30)) (_ bv10 30)) (_ bv9 30)) (_ bv8 30)) (_ bv7 30)) (_ bv6 30)) (_ bv5 30)) (_ bv4 30)) (_ bv3 30)) (_ bv2 30)) (_ bv1 30)) (_ bv0 30))
)

(define-fun cto ((v (_ BitVec 30))) (_ BitVec 30)
 (ctz (bvnot v))
)

(define-fun clo ((v (_ BitVec 30))) (_ BitVec 30)
 (clz (bvnot v))
)

(define-fun odd ((v (_ BitVec 30))) Bool
 (= ((_ extract 0 0) v) #b1)
)

(define-fun zero () (_ BitVec 30)
 (_ bv0 30)
)

(define-fun one () (_ BitVec 30)
 (_ bv1 30)
)

(define-fun ones () (_ BitVec 30)
 (bvnot zero)
)

(define-fun w () (_ BitVec 30)
 (_ bv30 30)
)

(define-fun IC ((s (_ BitVec 30)) (tx (_ BitVec 30)) (tn (_ BitVec 4)) (xlo (_ BitVec 30)) (xhi (_ BitVec 30))) Bool
 (and
  (or
   (and (= tn (_ bv0 4)) (= ((_ extract 29 29) tx) #b0))
   (and (= tn (bvnot (_ bv0 4))) (= ((_ extract 29 29) tx) #b1))
  )
  (mcb xlo xhi tx)
 )
)

(define-fun LIT ((x (_ BitVec 30))) Bool
 (= ((_ sign_extend 4) x) (concat tn tx))
)

; valid xlo/xhi pairs
(assert (= (bvor (bvnot xlo) xhi) ones))

(assert
 (distinct
  (IC s tx tn xlo xhi)
  (exists ((x (_ BitVec 30)))
   (and
    (mcb xlo xhi x)
    (LIT x)
   )
  )
 )
)

(check-sat)
(exit)
